package org.rcisoft.business.bagency.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bagency.entity.BAgency;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
* Created with  on 2018-4-4 8:57:37.
*/
@Repository
public interface BAgencyRepository extends BaseMapper<BAgency> {

    /**
    * 分页查询 bAgency
    *
    */
    @Select("<script>select * from b_agency where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BAgency> queryBAgencys(BAgency bAgency);

    /**
     * 根据条件查询
     * @param bAgency
     * @return
     */
    List<BAgency> listBAgencys(BAgency bAgency);

    @Select("<script>select distinct b_agency.business_id,b_agency.code,b_agency.name from b_agency "
            + " left join b_edu_class on b_edu_class.agency_id = b_agency.business_id\n"
            + " left join b_sl on b_sl.edu_class_id = b_edu_class.business_id"
            + " where 1=1 and term_code = #{termCode}"
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BAgency> queryMoreByPagination(BAgency bAgency);

    @Select("<script>SELECT ba.* FROM b_agency ba \n" +
            "RIGHT JOIN b_teacher bt ON ba.`code` = bt.agency_code\n" +
            "WHERE ba.business_id = #{businessId} AND ba.del_flag = 0 AND ba.flag = 1 AND bt.del_flag = 0 AND bt.flag = 1"
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BAgency> queryTeacherAgency(String businessId);

    @Select("<script>SELECT ba.* FROM b_agency ba \n" +
            "RIGHT JOIN b_company bc ON ba.`code` = bc.agency_code\n" +
            "WHERE ba.business_id = #{businessId} AND ba.del_flag = 0 AND ba.flag = 1 AND bc.del_flag = 0 AND bc.flag = 1"
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BAgency> queryCompanyAgency(String businessId);


    @Select("select * from b_agency where code = #{code} and del_flag = 0 and flag = 1")
    @ResultMap(value = "BaseResultMap" )
    List<BAgency> queryBAgencysByCode(String code);

    @Select("select * from b_agency where business_id = #{businessId} and del_flag = 0 and flag = 1")
    @ResultMap(value = "BaseResultMap" )
    BAgency selectOneBagency(String businessId);
}

