package org.rcisoft.business.bagency.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;


/**
* Created with  on 2018-4-4 8:57:36.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_agency")
public class BAgency  extends IdEntity<BAgency> {

    private static final long serialVersionUID = 4660799781307219222L;
    /*代理商编号*/
     @Length(min= 1 , max = 64, message = "长度最小为1,最大为50")
     @NotBlank
     private String code;

     /*代理商名*/
     @Length(min = 1, max = 50, message = "长度最小为1，最大为50")
     @NotBlank
     private String name;

    @Transient
    private String termCode;

    public BAgency(String code) {
        this.code = code;
    }

//   public BAgency(String businessId, String del_flag, String flag){
//        this.businessId = businessId;
//        this.delFlag = del_flag;
//        this.flag = flag;
//   }

}

