package org.rcisoft.business.barrange.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.barrange.entity.BArrange;
import org.rcisoft.business.barrange.entity.BSubAgency;
import org.rcisoft.business.barrange.entity.BSubtask;
import org.rcisoft.business.barrange.entity.ScheduleDto;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.ArrayList;
import java.util.List;

/**
* Created with  on 2018-4-19 10:28:59.
*/
@Repository
public interface BArrangeRepository extends BaseMapper<BArrange> {


    //企业人员查看自身公司的排课信息-------------------------------------------------------------------------------------
    @Select("<script>select b_arrange.business_id,term_code,b_term.name as term_name,description,agency_code,b_arrange.status from b_arrange "
            + "LEFT JOIN b_subtask ON b_arrange.business_id = b_subtask.arrange_id "
            + "LEFT JOIN b_sub_agency ON b_subtask.business_id = b_sub_agency.subtask_id "
            + "LEFT JOIN b_term ON b_term.code = b_arrange.term_code "
            + "where 1=1 and agency_code = #{agencyCode} "
            + "<if test=\"delFlag !=null and delFlag != '' \">and b_arrange.del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and b_arrange.flag = #{flag} </if> "
            + "<if test=\"status !=null and status != '' \">and FIND_IN_SET(b_arrange.`status`,#{status}) </if> "
            + "GROUP BY b_arrange.business_id order by b_arrange.status,b_arrange.create_date desc "
            + "</script>")
    @ResultMap(value = "BaseResultMapByAgencyCode")
    List<BArrange> queryByAgencyCode(BArrange bArrange);

    List<BSubtask> queryByAgencyCode2(String agencyCode);

    List<BSubtask> queryByAgencyCode3(String agencyCode);

    //-----------------------------------------------------------------------------------------------------------------

    //维护人员查看全部的排课信息----------------------------------------------------------------------------------------
    @Select("<script>select b_arrange.*,b_term.name from b_arrange left join b_term on b_term.code = b_arrange.term_code where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and b_arrange.del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and b_arrange.flag = #{flag} </if> "
            + "<if test=\"termCode !=null and termCode != '' \">and term_code = #{termCode} </if> "
            + "<if test=\"status !=null and status != '' \">and b_arrange.status = #{status} </if> "
            + "order by b_arrange.status,b_arrange.create_date desc"
            + "</script>")
    @ResultMap(value = "BaseResultMap2")
    List<BArrange> queryAll(BArrange bArrange);


    @Select("<script>select name,business_id,status from b_subtask where 1=1 "
            + "and del_flag = 0 "
            + "and flag = 1 "
            + "and arrange_id = #{businessId} GROUP BY name order by subtask_seq "
            + "</script>")
    @ResultMap(value = "bSubtaskResultMap")
    List<BSubtask> queryBSubtask(String businessId);

    @Select("<script>select b_sub_agency.*,b_agency.name from b_sub_agency "
            + "left join b_agency on b_sub_agency.agency_code = b_agency.code "
            + "where 1=1 "
            + "and b_sub_agency.del_flag = 0 "
            + "and b_sub_agency.flag = 1 and subtask_id = #{businessId} order by sub_agency_seq"
            + "</script>")
    @ResultMap(value = "BSubAgencyResultMap")
    List<BSubtask> queryBSubtask1(String businessId);

    //-----------------------------------------------------------------------------------------------------------------


//    @Select("<script>select * from b_schedule_dto LEFT JOIN b_sub_agency on b_schedule_dto.sub_agency_id = b_sub_agency.business_id " +
//            "LEFT JOIN b_arrange on b_subtask.arrange_id = b_arrange.business_id where 1=1 " +
//            "and b_subtask.business_id = #{bSubtaskId}" +
//            "</script>")
//    @ResultMap(value = "scheduleDtoResultMap")
//    List<ScheduleDto> queryDtoByAgencySubtaskId(String bSubtaskId);

    @Select("<script>select b_schedule_dto.*,b_edu_class.class_name,b_lesson.lesson_name,b_rooms.classroom_name,s_user.`name` as teacher_name from b_schedule_dto  " +
            "LEFT JOIN b_edu_class on b_edu_class.`code` = b_schedule_dto.class_code " +
            "LEFT JOIN b_lesson on b_lesson.`code` = b_schedule_dto.lesson_code " +
            "LEFT JOIN b_rooms on b_rooms.`code` = b_schedule_dto.room_code " +
            "LEFT JOIN b_teacher on b_teacher.`code` = b_schedule_dto.teacher_code " +
            "LEFT JOIN s_user on s_user.login_name = b_teacher.`code` " +
            "where sub_agency_id = #{subAgencyId} " +
            "ORDER BY dto_seq,lesson_code,class_code,teacher_code,week " +
            //"GROUP BY lesson_code,teacher_code,class_code " +
            "</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryDtoBySubAgencyId(String subAgencyId);

    @Select("<script>select * from b_schedule_dto LEFT JOIN b_subtask on b_schedule_dto.subtask_id = b_subtask.business_id " +
            "LEFT JOIN b_arrange on b_subtask.arrange_id = b_arrange.business_id where 1=1 " +
            "and b_arrange.term_code = #{2} and b_subtask.name = #{1} and b_subtask.agency_code = #{0} " +
            "<if test=\"teacherCode !=null and teacherCode != '' \">and teacher_code = #{teacherCode} </if> " +
            "</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryDtoByAgencyMany(String agencyCode,String name,String termCode,@Param("teacherCode") String teacherCode);

    @Select("select business_id from b_sub_agency where subtask_id = #{subTaskId} and del_flag = 0 and flag = 1")
    List<String> querySubAgencyId(String subTaskId);

    @Select("select DISTINCT(status) from b_sub_agency where subtask_id = #{subTaskId} and del_flag = 0 and flag = 1")
    List<String> querySubTaskStatus(String subTaskId);

    int insertList(ArrayList<ScheduleDto> list);

    int insertBSubtask(List<BSubtask> list);

    int insertBSubAgency(List<BSubAgency> list);

    //按id查
    @Select("<script>select b_arrange.business_id,term_code,description,agency_code,b_arrange.status from b_arrange "
            + "LEFT JOIN b_subtask ON b_arrange.business_id = b_subtask.arrange_id "
            + "LEFT JOIN b_sub_agency ON b_subtask.business_id = b_sub_agency.subtask_id "
            + "where 1=1 and b_arrange.business_id = #{0} "
            + "GROUP BY b_arrange.business_id "
            + "</script>")
    @ResultMap(value = "BaseResultMapByAgencyCode")
    BArrange selectArrangeById(String businessId);

    @Select("<script>select term_code from b_arrange "
            + "left join b_subtask on b_subtask.arrange_id = b_arrange.business_id "
            + "left join b_sub_agency on b_sub_agency.subtask_id = b_subtask.business_id "
            + "where b_sub_agency.business_id =  #{bSubAgencyId} "
            + "</script>")
    String selectTermCodeByBSubtaskId(String bSubAgencyId);

    @Select("<script>select *,b_term.`name` as term_name,b_subtask.`name` as subtask_name,b_sub_agency.`status` as sub_agency_status from b_sub_agency "
            + "LEFT JOIN b_subtask on b_sub_agency.subtask_id = b_subtask.business_id "
            + "LEFT JOIN b_arrange on b_subtask.arrange_id = b_arrange.business_id "
            + "LEFT JOIN b_term on b_arrange.term_code = b_term.`code` "
            + "WHERE b_sub_agency.business_id =  #{bSubAgencyId} "
            + "</script>")
    @ResultMap(value = "selectSubAgencyAndOptionResultMap")
    BSubAgency selectSubAgencyAndOption(String bSubAgencyId);

    /**
     * 子任务提交 修改status 0 -> 2
     * @param businessId
     * @return
     */
    @Update("update b_sub_agency set status = 2 where business_id = #{0}")
    int submitSubAgency(String businessId);

    @Delete("delete from b_schedule_dto where sub_agency_id = #{bSubAgencyId}")
    int avoidRepeatDto(String bSubAgencyId);

    @Update("update b_arrange set del_flag = 1 where business_id = #{0}")
    int deleteArrange(String businessId);

    @Select("select count(*) from b_schedule_dto where room_code = ( select `code` from b_rooms where business_id = #{businessId})")
    int countThisRoomNum(String businessId);

    @Select("<script>select b_schedule_dto.*,b_edu_class.class_name,b_lesson.lesson_name,b_rooms.classroom_name,s_user.`name` as teacher_name from b_schedule_dto  " +
            "LEFT JOIN b_edu_class on b_edu_class.`code` = b_schedule_dto.class_code " +
            "LEFT JOIN b_lesson on b_lesson.`code` = b_schedule_dto.lesson_code " +
            "LEFT JOIN b_rooms on b_rooms.`code` = b_schedule_dto.room_code " +
            "LEFT JOIN b_teacher on b_teacher.`code` = b_schedule_dto.teacher_code " +
            "LEFT JOIN s_user on s_user.login_name = b_teacher.`code` " +
            "where sub_agency_id = #{subAgencyId} " +
            "GROUP BY lesson_code,teacher_code,class_code " +
            "</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryLessonsBySubAgencyId(String subAgencyId);

    @Select("<script>select * from b_schedule_dto " +
            "where sub_agency_id = #{subAgencyId} and class_code = #{classCode} and lesson_code = #{lessonCode} " +
            "GROUP BY dto_seq " +
            "</script>")
    @ResultMap(value = "scheduleDtoResultMap")
    List<ScheduleDto> queryDtoThroughBsl(@Param("subAgencyId") String subAgencyId,@Param("classCode") String classCode,@Param("lessonCode") String lessonCode);
}

