package org.rcisoft.business.barrange.dao;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.barrange.entity.BSubtask;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface BSubtaskRepository  extends BaseMapper<BSubtask> {

//    @Select("SELECT DISTINCT(`status`) from b_subtask\n" +
//            "where arrange_id = \n" +
//            "(SELECT arrange_id FROM b_subtask where business_id = #{subTaskId})")
    @Select("SELECT DISTINCT(status) from b_subtask where arrange_id = #{0} and del_flag = 0")
    List<String> querySubTaskStatusById(String arrangeId);

    @Select("SELECT arrange_id FROM b_subtask where business_id = #{subTaskId}")
    String queryArrangeIdById(String subTaskId);

    @Delete("delete from b_subtask where arrange_id = #{0}")
    void deleteSubtask(String businessId);

    @Select("select COUNT(*) from b_subtask where status != '5' and arrange_id = #{arrangeId}")
    int judgeSubtask(String arrangeId);

    @Select("select arrange_id from b_subtask where business_id = #{businessId}")
    int getArrangeId(String businessId);
}
