package org.rcisoft.business.barrange.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with  on 2018-4-19 10:28:59.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_arrange")
public class BArrange  extends IdEntity<BArrange> {

     private static final long serialVersionUID = -5524520301999990921L;

     /*学期编号*/
     @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
     @NotBlank
     private String termCode;

     /*描述*/
     @Length(min = 1,max = 255,message = "长度最小为1,最大为250")
     private String description;

     /*状态*/
//     @Length(min = 1,max = 2,message = "长度最小为1，最大为2")
//     @NotBlank
     private String status;

     @Transient
     private String agencyCode;
//
//     @Transient
//     private List<BArrange> childList;

     @Transient
     private List<BSubtask> childList;

     public BArrange(String businessId, String status) {
          this.businessId = businessId;
          this.status = status;
     }
     @Transient
     private String termName;

}

