package org.rcisoft.business.barrange.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with  on 2018-4-25 16:58:44.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_subtask")
public class BSubtask  extends IdEntity<BSubtask> {

     private static final long serialVersionUID = 2820764374091464639L;

     private String arrangeId;

     @Length(min = 1 , max = 256 ,message = "长度最小为1，最大为250")
     @NotBlank
     private String name;

     /**
      * 审核状态 0：未提交 1：已提交 2：通过
      */
     private String status;

     private String gradeCode;

     private String subtaskSeq;

     @Transient
     private List<BSubAgency> childList;

     @Transient
     private String agencyCode;



    public BSubtask(String businessId, String status) {
         this.businessId = businessId;
         this.status = status;
    }
}

