package org.rcisoft.business.barrange.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Transient;

/**
 * Created by Administrator on 2018/4/23.
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class ScheduleDto extends IdEntity<ScheduleDto>{

    private static final long serialVersionUID = 281845068673189421L;
    /*课程编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String lessonCode;

    @Transient
    private String lessonName;

    /*教师编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String teacherCode;

    @Transient
    private String teacherName;

    /*班级编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String classCode;

    @Transient
    private String className;

    /*持续周*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String week;

    /*课时*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String classHour;

    /*周一 以此类推*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String monday;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String tuesday;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String wednesday;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String thursday;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String friday;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String saturday;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String sunday;

    /*教室编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String roomCode;

    /*公司任务ID*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String subAgencyId;

    /*排序*/
    private String dtoSeq;

    private int lessonCell;

    private int teacherCell;

    private int classCell;

    private int roomCell;

    @Transient
    private String roomName;


}
