package org.rcisoft.business.bcarousel.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.bcarousel.entity.BCarousel;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with gwf on 2017-8-4 16:30:27.
*/
@Repository
public interface BCarouselRepository extends BaseMapper<BCarousel> {

    /**
    * 根据imageid查找
    * @param param
    * @return
    */
    @Select("<script>select * from b_carousel where del_flag='0' and flag = '1'  and image_id=#{imageId} <if test=\"isOpen!=null\">and is_open=#{isOpen}</if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BCarousel> queryBCarousels(Map<String, Object> param);

    @Update("<script>update b_carousel set carousel_des = #{carouselDes}, " +
            "carousel_url = #{carouselUrl}, " +
            "carousel_sort = #{carouselSort}, " +
            "is_open = #{isOpen}, " +
            "is_new_window = #{isNewWindow}, " +
            "image_type = #{imageType}, " +
            "link_url = #{linkUrl}, " +
            "image_id = #{imageId}, " +
            "update_date = #{updateDate} " +
            "where business_id  = #{businessId}</script>")
    int updateCarouselById(BCarousel model);
}

