package org.rcisoft.business.bcarousel.entity;


import lombok.AllArgsConstructor;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import lombok.Data;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
* Created with gwf on 2017-8-4 16:30:26.
*/
@Entity
@Table(name = "b_carousel")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BCarousel extends IdEntity<BCarousel> {

    private static final long serialVersionUID = -4024897937254829705L;
    /*轮播描述*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为256")
    @NotBlank
    private String carouselDes;
    /*轮播图片*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为256")
    @NotBlank
    private String carouselUrl;
    /*排序*/
    private Integer carouselSort;
    /*是否显示 0未显示，1显示*/
    private String isOpen;
    /*是否跳转窗口*/
    private String isNewWindow;
    /*链接*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为256")
    @NotBlank
    private String linkUrl;
    /*图片类型*/
    @Length(min = 1,max = 32,message = "长度最小为1,最大为32")
    @NotBlank
    private String imageType;
    /*图片id*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为64")
    @NotBlank
    private String imageId;

}

