package org.rcisoft.business.bchapter.service;


import org.rcisoft.business.bchapter.dto.*;
import org.rcisoft.business.bchapter.entity.BChapter;
import org.rcisoft.business.bchapter.vo.StudentChapterScoreVO;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;

import java.util.List;

/**
 * Created by gwf on 2017-7-21 15:08:47.
 */
public interface BChapterService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BChapter selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BChapter> queryBChaptersByPagination(PageUtil pageUtil, BChapter model);

    /**
     * 根据章节id查找学生分数信息
     * @param dto
     * @return
     */
    List<StudentChapterScoreVO> queryScoreListByChapterIdByPagination(PageUtil pageUtil, QueryScoreListDTO dto);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BChapter> queryBChapters(BChapter model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BChapter model, String token);

    /**
     * 修改
     * @param model
     * @return
     */
    PersistModel update(BChapter model);

    /**
    * 逻辑删除
    * @param id
    * @return
    */
    PersistModel removeBChapter(String id,String token);

    /**
     * 打分
     * @param scoreInfoDTOS
     * @return
     */
    void markScore(List<ScoreInfoDTO> scoreInfoDTOS,String lessonOrSl);

    /**
     * 根据学生id和课程id获取该学生的课程章节分数列表
     * @param slid
     * @param stuid
     * @return
     */
    List<StuScoreDTO> queryScoreListBySlIdAndStuId(String slid, String stuid);


    /**
     * 打回重做
     * @param chapterId
     * @param studentCode
     */
    void deleteScoerInfo(String chapterId, String studentCode);

    /**
     * 更新已经完成状态
     * @param scoreInfoDTO
     */
    void updateIsComplete(ScoreInfoDTO scoreInfoDTO,String token) throws Exception;

    /*
    * 根据学生ID和章节ID查询该节的学习情况
    * */
    ScoreInfoDTO getChapInfoById(ScoreInfoDTO scoreInfoDTO) throws Exception;

    int addBslFormLesson(String bLseeonId, String lessonCode, String businessId);

    int updateChapterState(BChapter bChapter);

    int updateAllChapterState(String slId);

    int updateTopChapter(BChapter bChapter);

    int updateDownChapter(BChapter bChapter);

    int updateAutomatic(String businessId);

    String queryMdFileByChapterId(String businessId);

    List<BChapter> queryBChaptersByStudent(BChapter param);

    int Mark(String chapterId, String slId, String studentCode, String score);

    List<ScoreReportDto> scoreReport(String slId);

    List<ChapterSelectDto> chapterListBySlId(String slId);

    String queryStuIdByCode(String code);

    int updateToFinish(String type, String studentCode, String chapterId ,String slId);

    String queryIsCompleteByUserIdAndChapId(String userInfoProp, String chapId);

    int updateMdFile(String businessId, String mdFile);
}
