package org.rcisoft.business.bclass.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bclass.entity.BClass;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Repository
public interface BClassRepository extends BaseMapper<BClass> {

    /**
    * 根据条件查找
    * @param bClass
    * @return
    */
//    @Select("<script>select * from b_class b where b.del_flag != 1" +
//            "<if test=\"name!=null\">and b.`class_name` like #{name} or b.`code` like #{name}</if>" +
//            "<if test=\"num!=null\">and b.`student_num` = #{num}</if></script>)")
//    @Select("select * from b_class")
//    @ResultMap(value = "BaseResultMap" )
    List<BClass> queryBClasss(BClass bClass);

    /**
     * 更新班级人数
     * @param param
     * @return
     */
    void updateStudentNum(Map<String, Object> param);


    @Insert("<script>INSERT INTO b_class" +
            "(create_date,update_date,del_flag,flag,business_id,code,class_name,grade_code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code},#{item.className},#{item.gradeCode})" +
            "</foreach></script>")
    int insertList(List<BClass> bClasses);

    @Insert("<script>INSERT INTO b_class" +
            "(create_date,update_date,del_flag,flag,business_id,code,class_name,grade_code,type,agency_code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code},#{item.className},#{item.gradeCode},#{item.type},#{item.agencyCode})" +
            "</foreach></script>")
    int insertBusinessClassList(List<BClass> bClasses);

    @Select("<script>select * from b_class where del_flag != 1 and flag = 1 " +
            "<if test=\"type!=null and type!=''\">and type = #{type} </if>" +
            "order by create_date desc</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BClass> queryBClassList(@Param("type") String type);

    @Select("select class_name from b_class where find_in_set(code,#{classesCode}) and del_flag != 1 and flag = 1")
    List<String> queryClassNamesByIds(String classesCode);

    @Select("select * from b_grade where code = #{gradeCode} and del_flag = 0 and flag = 1")
    List<BClass> checkGrade(BClass bClass);

    @Select("<script>select * from b_class where  " +
            "class_name = #{className} and business_id != #{businessId}</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BClass> selectClassesByName(BClass bClass);

    @Update("UPDATE b_class SET student_num = (student_num-1) WHERE FIND_IN_SET(`code`,#{classCodes})")
    int updateStudentNumByClassCodes(String classCodes);
}

