package org.rcisoft.business.bclass.service;


import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.bclass.entity.BClass;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.model.SelectModel;

import java.io.IOException;
import java.util.List;

/**
 * Created by CodeGenerator on 2017/07/12.
 */
public interface BClassService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BClass selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BClass> queryBClasssByPagination(PageUtil pageUtil, BClass model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BClass> queryBClasss(BClass model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BClass model,String token);

    /**
     * 逻辑删除
     * @param id
     * @return
     */
    PersistModel removeBClass(String id);

    /**
     * excel导入
     * @param
     * @return
     */
//    PersistModel importExcel(HSSFWorkbook hwb, String token) throws IOException;

    /**
     * 行政班excel导入
     * @param hwb
     * @param token
     * @return
     * @throws IOException
     */
    PersistModel administrativeImportExcel(HSSFWorkbook hwb, String token) throws IOException;

    /**
     * 企业版excel导入
     * @param hwb
     * @param token
     * @return
     * @throws IOException
     */
    PersistModel businessImportExcel(HSSFWorkbook hwb, String token) throws IOException;

    List<SelectModel> queryBClassList(String type);
}
