package org.rcisoft.business.bcode.service;

import org.rcisoft.business.bcode.model.BCodeFile;
import org.rcisoft.business.bcode.model.StudentFile;
import org.rcisoft.core.result.CommandResult;

import java.util.List;

/**
 * Created by lcy on 18/1/3.
 */
public interface BCodeService {
    /**
     * 读取文件内容
     * @param slId
     * @param chapId
     * @param examType
     * @param userInfoProp
     * @return
     */
    List<BCodeFile> readExamFiles(String slId, String chapId, String examType, String userInfoProp, String StudentCode);


    /**
     * 将代码写入文件
     * @param slId
     * @param chapId
     * @param examType
     * @param content
     * @param userInfoProp
     * @return
     */
    BCodeFile saveOwnExamFiles(String slId, String chapId, String examType, String content, String userInfoProp, String studentCode);

    String exportFiles(String slId, String studentId, String type, String slCode);

    List<StudentFile> queryAllStudentCode(String slId, String chapterId);

    /**
     * 判断是否开启
     *
     * @param userId
     * @return  1 未开
     *          0 已开
     */
    Integer isOpenLxcFromUser(String userId,String slId,String chapterId);

    /**
     * 关闭 实验环境
     * @param userId
     * @return
     */
    CommandResult stopExam(String userId);

    int getIntelligenceScore(String slId, String chapterId, String studentCode);
    /**
     * 延长  实验环境
     * @param userInfoProp
     * @return
     */
    CommandResult delayExam(String userInfoProp);

    List<BCodeFile> queryStudentExamFiles(String slId, String chapId, String examType, String studentCode);

    int checkStudentFiles(String slId);
}
