package org.rcisoft.business.bcoursecode.dao;

import org.apache.ibatis.annotations.Update;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bcoursecode.entity.BCourseCode;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.core.model.PersistModel;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2018-4-17 11:12:17.
*/
@Repository
public interface BCourseCodeRepository extends BaseMapper<BCourseCode> {

    /**
    * 分页查询 bCourseCode
    *
    */
    @Select("<script>select * from b_course_code where 1=1 "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "order by seq asc</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BCourseCode> queryBCourseCodes(BCourseCode bCourseCode);

    /**
     * 启用标志位
     * @param businessId
     * @return
     */
    @Update("update b_course_code set flag = 1 where business_id = #{0}")
    int startFlag(String businessId);

    /**
     * 停用标志位
     * @param businessId
     * @return
     */
    @Update("update b_course_code set flag = 0 where business_id = #{0}")
    int stopFlag(String businessId);

    /**
     * 查询停用条数
     * @param id
     * @return
     */
    @Select("select count(*) from b_course_code where business_id > #{id} and flag=1 and del_flag = 0 ")
    int select_flag_stop(int id);

    /**
     * 查询启用条数
     * @param id
     * @return
     */
    @Select("select count(*) from b_course_code where business_id < #{id} and flag=0 and del_flag = 0 ")
    int select_flag_start(int id);

    /**
     * 查询节点当前启用/停用状态
     * @param businessId
     * @return
     */
    @Select("select flag from b_course_code where business_id = #{0} and del_flag = 0")
    String querystatus(String businessId);

}

