package org.rcisoft.business.bcoursecode.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with  on 2018-4-17 11:12:17.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_course_code")
public class BCourseCode  extends IdEntity<BCourseCode> {


     private static final long serialVersionUID = 6659179609972376021L;

     /*节点顺序*/
     @Length(min = 1,max = 10,message = "长度最小为1,最大为10")
     @NotBlank
     private Integer seq;

     /*开始时间*/
     @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
     @NotBlank
     private String startDate;

     /*结束时间*/
     @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
     @NotBlank
     private String endDate;

     /*节点描述*/
     @Length(min = 1,max = 1,message = "长度为1")
     @NotBlank
     private String dateDesc;

     /*public String getDateDesc(){
          switch (this.dateDesc) {
               case "0":
                    return "上午";
               case "1":
                    return "下午";
               default:
                    return "晚上";
          }
     }*/

}

