package org.rcisoft.business.bdirection.dao;


import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bdirection.entity.BDirection;
import org.rcisoft.business.blesson.entity.BLessonDirection;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with  on 2017-12-19 13:45:42.
*/
@Repository
public interface BDirectionRepository extends BaseMapper<BDirection> {

    @Select("<script>select * from b_direction where 1=1  and del_flag = 0 and flag = 1 " +
            "<if test=\"name!=null and name != ''\">\n" +
            "   AND  name LIKE CONCAT('%',#{name},'%')\n" +
            "</if>\n" +
            "<if test=\"code!=null and code != ''\">\n" +
            "   AND code LIKE CONCAT('%',#{code},'%')\n" +
            "</if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BDirection> queryDirections(BDirection param);


    @Select("<script>select * from b_direction where code = #{code} and del_flag = 0 and flag = 1 </script>")
    @ResultMap(value = "BaseResultMap")
    BDirection queryDirectionByCode(String code);

    @Select("<script>select count(*) from b_lesson_direction where direction_id = #{id} </script>")
    int selectslNumById(String id);

    @Select("<script>select * from b_direction where del_flag != 1 and flag = 1</script>")
    @ResultMap(value = "BaseResultMap")
    List<BDirection> queryDirectionsList();

    @Insert("insert into b_lesson_direction (business_id,direction_id,sl_id,lession_id) values (#{businessId},#{directionId},#{slId},#{lessionId})")
    int insertBLessonDirection(BLessonDirection bDirection);

    @Select("<script>select * from b_direction where name = #{name} and del_flag = 0 and flag = 1 </script>")
    @ResultMap(value = "BaseResultMap")
    BDirection queryDirectionByName(String name);

    @Insert("<script>INSERT INTO b_lesson_direction" +
            "(business_id,direction_id,sl_id,lession_id)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.businessId},#{item.directionId},#{item.slId},#{item.lessionId})" +
            "</foreach></script>")
    int insertList(List<BLessonDirection> bLessonDirections);
}

