package org.rcisoft.business.beduclass.dao;

import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.beduclass.entity.BEduClass;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2018-4-17 14:33:36.
*/
@Repository
public interface BEduClassRepository extends BaseMapper<BEduClass> {

    /**
    * 分页查询 bEduClass
    *
    */
    @Select("<script>select ec.*,bg.`name` as gradeName from b_edu_class ec " +
            "LEFT JOIN b_grade bg on ec.grade_id = bg.`code` " +
            " where 1=1  "
            + "<if test=\"delFlag !=null and delFlag != '' \">and ec.del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and ec.flag = #{flag} </if> "
            + "<if test=\"className !=null and className != '' \">and ec.class_name LIKE CONCAT('%',#{className},'%') </if>"
            + "<if test=\"code !=null and code != '' \">and ec.code LIKE CONCAT('%',#{code},'%') </if>"
            +  "order by create_date desc"
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BEduClass> queryBEduClasss(BEduClass bEduClass);

    @Select("<script>select ec.*,bg.`name` as gradeName from b_edu_class ec\n" +
            "LEFT JOIN b_grade bg ON ec.grade_id = bg.`code`\n" +
            "where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    BEduClass selectDetalInfo(String id);

    @Select("SELECT class_name,class_code from b_schedule_dto " +
            "left JOIN b_edu_class on b_schedule_dto.class_code = b_edu_class.code where sub_agency_id = #{subAgencyId} GROUP BY `code` ")
    @ResultMap(value = "SmallBaseResultMap" )
    List<BEduClass> selectClassBySubAgencyId(String subAgencyId);



}

