package org.rcisoft.business.beduclass.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with  on 2018-4-17 14:33:36.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "b_edu_class")
public class BEduClass  extends IdEntity<BEduClass> {


     private static final long serialVersionUID = 1330074578479142863L;

     public BEduClass(String code) {
          this.code = code;
     }

     /*教学班编号*/
     @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
     @NotBlank
     private String code;

     /*教学班名*/
     @Length(min = 1,max = 150,message = "长度最小为1,最大为50")
     @NotBlank
     private String className;



     /*企业Id*/
     private String agencyId;

     /*教学班类型*/
     private String type;

     /*子班级ID串*/
     private String classesId;

     /*学年ID*/
     private String gradeId;

     @Transient
     private String classNames;

     @Transient
     private String gradeName;

     @Transient
     private int studentNum;
}

