package org.rcisoft.business.bfile.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
* Created with gaowenfneg on 2017-10-9 14:34:56.
*/
@Entity
@Table(name = "b_file")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BFile extends IdEntity<BFile> {

    private static final long serialVersionUID = 5501554322621964535L;
    /*视频名称*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String videoName;

    /*视频地址*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String videoUrl;

    /*'0'为视频，'1'为附件*/
    private String type;

    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String fileUrl;

    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String pptUrl;

    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String pdfUrl;

    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String lessonId;//课程ID

    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String slId;//开课ID

    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String chapterId;//节ID
}

