package org.rcisoft.business.bfile.service;

import org.rcisoft.business.bfile.entity.BFile;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;

/**
 * Created by gaowenfneg on 2017-10-9 14:34:56.
 */
public interface BFileService {
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BFile selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BFile> queryBVideosByPagination(PageUtil pageUtil, BFile model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BFile> queryBVideos(BFile model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BFile model);

    /**
    * 逻辑删除
    * @param id
    * @return
    */
    PersistModel removeBVideo(String id, String token);

    public String uploadVideoToServer(List<MultipartFile> list, BFile bFile, String token);

    public BFile queryFileUrlByChapterId(String chapterId);

    /**
     * 将license证书文件输出到指定路径下
     * @param file
     */
    public void uploadLicense(MultipartFile file) throws IOException;

    List<String> reConversionPPT(String businessId, String type);
}
