package org.rcisoft.business.bgrade.dao;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.bgrade.entity.BGrade;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with  on 2018-4-17 15:09:18.
*/
@Repository
public interface BGradeRepository extends BaseMapper<BGrade> {

    /**
    * 分页查询 bGrade
    *
    */
    @Select("<script>select * from b_grade where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "order by code desc"
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BGrade> queryBGrades(BGrade bGrade);

    /**
      查询是否有本年的年级
     */
    @Select("<script>select * from b_grade where code = #{nowYear} order by create_date desc</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BGrade> queryBGradeByNowYear(String nowYear);

    /*
    查询近5年的年级
     */
    @Select("<script>select * from b_grade where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "order by code desc "
            + "limit 5</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BGrade> queryFirstFiveBGrades(BGrade bGrade);

    @Delete("delete from b_grade")
    int deleteAll();

    @Insert("<script>INSERT INTO b_grade" +
            "(create_date,update_date,create_by,update_by,remarks,del_flag,flag,business_id," +
            "code,name)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.createBy},#{item.updateBy},#{item.remarks},#{item.delFlag}," +
            "#{item.flag},#{item.businessId},#{item.code},#{item.name})" +
            "</foreach></script>")
    int insertList(List<BGrade> newGrades);
}

