package org.rcisoft.business.bnews.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bnews.entity.BNews;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with gwf on 2017-8-10 11:05:34.
*/
@Repository
public interface BNewsRepository extends BaseMapper<BNews> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>SELECT\n" +
            "\tt1.business_id,t1.create_by,t1.create_date,t1.update_by,t1.update_date," +
            "\tt1.del_flag,t1.flag,t1.remarks,t1.news_name,t1.news_code,t1.release_time," +
            "\tt1.attribute,t1.is_release\n" +
            "FROM\n" +
            "\tb_news t1\n" +
            "WHERE\n" +
            "\tt1.del_flag = 0\n" +
            "AND t1.flag = 1\n" +
            "<if test=\"attribute!=null\">AND t1.attribute = #{attribute}</if>\n" +
            "<if test=\"release!=null\">AND t1.is_release = #{release}</if>\n" +
            "AND t1.news_name like #{newsName} " +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BNews> queryBNewss(Map<String, Object> param);
}

