package org.rcisoft.business.bnews.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Calendar;
import java.util.Date;
import java.util.Random;

/**
* Created with gwf on 2017-8-10 11:05:34.
*/
@Entity
@Table(name = "b_news")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BNews extends IdEntity<BNews> {

    private static final long serialVersionUID = 620940318267006837L;

    public void autoSetApplyCode(){
        Calendar calendar = Calendar.getInstance();
        StringBuilder applyCode = new StringBuilder();
        Random random = new Random();
        String month = "";
        int canMonth = calendar.get(Calendar.MONTH);
        if(canMonth<9)
            month = "0"+(canMonth+1);
        else if(canMonth==9)
            month = "10";
        else
            month = String.valueOf(month+1);
        applyCode
                .append(calendar.get(Calendar.YEAR))
                .append(month)
                .append(calendar.get(Calendar.DATE))
                .append(calendar.get(Calendar.HOUR))
                .append(calendar.get(Calendar.MINUTE))
                .append(calendar.get(Calendar.SECOND))
                .append(random.nextInt(1000));
        this.setNewsCode(applyCode.toString());
    }

    public BNews(String newsCode) {
        this.newsCode = newsCode;
    }

    /*新闻标题*/
    @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
    @NotBlank
    private String newsName;
    /*新闻code*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String newsCode;
    /*发布时间*/
    private Date releaseTime;
    /*0：非头条，1：头条*/
    private String attribute;
    /*0未发布，1：发布*/
    private String isRelease;
    /*新闻内容*/
    private String newsContent;


}

