package org.rcisoft.business.bopinion.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.rcisoft.business.barrange.entity.BSubtask;
import org.rcisoft.business.bopinion.entity.BOpinion;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by Administrator on 2017/12/21.
 */
@Repository
public interface BOpinionRepository extends BaseMapper<BOpinion> {

    @Select("select b_opinion.*,s_user.name as create_person from b_opinion left join s_user on b_opinion.create_by = s_user.business_id " +
            "where sl_id = #{slId} order by create_date DESC")
    @ResultMap(value = "BaseResultMap")
    List<BOpinion> queryOpinionBySlId(String slId);

    /**
     * 审核通过 通过已提交的
     * @param businessId
     * @return
     */
    @Update("update b_sub_agency set status = 3 where business_id = #{0} and del_flag = 0 and flag = 1 and status = 2")
    int changeSubtaskStatus(String businessId);

    /**
     * 查询驳回的子任务信息
     * @param id
     * @return
     */
    @Select("select * from b_subtask where business_id = #{0} and del_flag = 0 and flag = 1")
    @ResultMap("SubTaskResult")
    BSubtask querySubtaskInfo(String id);


    @Select("select b_opinion.*,s_user.name as create_person from b_opinion left join s_user on b_opinion.create_by = s_user.business_id " +
            "where b_opinion.sub_agency_id = #{subAgencyId} order by create_date DESC")
    @ResultMap(value = "BaseResultMap")
    List<BOpinion> queryOpinionBySubAgencyId(String subAgencyId);

}
