package org.rcisoft.business.brclassstudent.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.brclassstudent.entity.BRClassStudent;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.security.access.method.P;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Repository
public interface BRClassStudentRepository extends BaseMapper<BRClassStudent> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>select * from b_r_class_student</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BRClassStudent> queryBRClassStudents(Map<String, Object> param);

    /**
     * 批量插入
     * @param brClassStudentList
     * @return
     */
    @Insert("<script>INSERT INTO b_r_class_student" +
            "(business_id,class_code,student_code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "(#{item.businessId},#{item.classCode},#{item.studentCode})" +
            "</foreach></script>")
    int insertList(List<BRClassStudent> brClassStudentList);

    /**
     * 根据班级编号和学生编号查询
     * @param brClassStudent
     * @return
     */
    @Select("<script>SELECT * FROM b_r_class_student  WHERE  class_code = #{classCode} AND student_code = #{studentCode}</script>")
    @ResultMap(value = "BaseResultMap" )
    BRClassStudent queryBRClassByCode(BRClassStudent brClassStudent);

    /**
     * 查询班级人数
     * @param classId
     * @return
     */
    @Select("<script>SELECT\n" +
            "\tCOUNT(b1.student_code)\n" +
            "FROM\n" +
            "\tb_r_class_student b1\n" +
            "LEFT JOIN b_class b2 ON b1.class_code = b2.`code`\n" +
            "WHERE\n" +
            "\tb2.business_id = #{classId}</script>")
    int selectStuentNumByClassId(String classId);

    /**
     * 根据学生code 删除所有记录
     * @param stuCode
     * @return
     */
    @Delete("delete from b_r_class_student where student_code = #{stuCode}")
    int deleteCSByStuId(String stuCode);

    @Select("<script>SELECT bcs.* FROM b_r_class_student bcs " +
            "LEFT JOIN b_class bc on bc.`code`=bcs.class_code " +
            "LEFT JOIN b_student bs on bs.`code`=bcs.student_code " +
            "WHERE bcs.student_code=#{studentCode} " +
            "AND bc.type=#{type}</script>")
    @ResultMap(value = "BaseResultMap" )
    BRClassStudent queryClassStudent(@Param("studentCode") String studentCode, @Param("type") String type);
}

