package org.rcisoft.business.brclassstudent.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.util.IdGen;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Entity
@Table(name = "b_r_class_student")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BRClassStudent {
    private static final long serialVersionUID = -5731693698871120506L;


    public BRClassStudent(String classCode, String studentCode) {
        this.classCode = classCode;
        this.studentCode = studentCode;
    }

    @Id
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    protected String businessId;
    /*班级编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String classCode;
    /*学生编号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String studentCode;


    /**
     * 通用设置ID
     */
    public void setCommonBusinessId(){
        this.setBusinessId(IdGen.uuid());
    }
}

