package org.rcisoft.business.brooms.utils;

import lombok.extern.slf4j.Slf4j;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.rcisoft.business.brooms.entity.BRooms;
import org.rcisoft.core.util.UserUtil;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.*;

@Slf4j
public class Upload2DataBase {

    public static Map<String,Object> DoIt(String path, List<String> AllCode){
        Map<String,Object> finalResult = new HashMap<String,Object>();
        //将数据存入此list
        List<BRooms> list = new ArrayList<>();
        //将code存入此list，方便查重
        List<String> currentlyCode = new ArrayList<>();
        String errorDetail = "";
        File file = new File(path);
        try {
            FileInputStream fis = new FileInputStream(file);
            Workbook workbook = null;
            if(file.getName().toLowerCase().endsWith("xlsx")){
                workbook = new XSSFWorkbook(fis);
            }else if(file.getName().toLowerCase().endsWith("xls")){
                workbook = new HSSFWorkbook(fis);
            }
            int numberOfSheets = workbook.getNumberOfSheets();
            //遍历所有Excel表
            for(int i=0; i < numberOfSheets; i++){
                Sheet sheet = workbook.getSheetAt(i);
                Iterator<Row> rowIterator = sheet.iterator();
                rowIterator.next();
                rowIterator.next();
                int location = 3;
                //遍历此表
                while(rowIterator.hasNext())
                {
                    Row row = rowIterator.next();
                    int j = 0;
                    BRooms bRooms = new BRooms();
                    String classroomName = "";
                    Iterator<Cell> cellIterator = row.cellIterator();
                    //将每格的值赋给上面的变量
                    while (cellIterator.hasNext())
                    {
                        Cell cell = cellIterator.next();
                        //如果某个值为空，则赋值给它
                        if(bRooms.getCampus() == null){
                            if(cell.getStringCellValue().trim().equals("校本部")){
                                bRooms.setCampus("0");
                                classroomName = "本校";
                            }else if(cell.getStringCellValue().trim().equals("新校区")){
                                bRooms.setCampus("1");
                                classroomName = "新校";
                            }
                        }else if(bRooms.getCode() == null){
                            bRooms.setCode(cell.getStringCellValue().trim());
                        }else if(bRooms.getBuilding() == null){
                            bRooms.setBuilding(cell.getStringCellValue().trim());
                            classroomName += bRooms.getBuilding();
                        }else if(bRooms.getClassroomNo() == null){
                            cell.setCellType(CellType.STRING);
                            bRooms.setClassroomNo(cell.getStringCellValue());
                            classroomName += bRooms.getClassroomNo();
                        }else if(bRooms.getCategory() == null){
                            String result = "";
                            switch (cell.getStringCellValue().trim()) {
                                case "普通教室":
                                    result = "0";
                                    break;
                                case "听力教室":
                                    result = "1";
                                    break;
                                case "多媒体教室":
                                    result = "2";
                                    break;
                                case "实训机房":
                                    result = "3";
                                    break;
                                case "报告厅":
                                    result = "4";
                                    break;
                                case "多功能报告厅":
                                    result = "5";
                                    break;
                                case "阶梯教室":
                                    result = "6";
                                    break;
                            }
                            bRooms.setCategory(result);
                        }else if(bRooms.getClassSeat() == null ){
                            bRooms.setClassSeat((int)cell.getNumericCellValue());
                        }
                    }
                    //判断是否与数据库有重复code
                    if(AllCode.contains(bRooms.getCode())){
                        errorDetail += "第 " + location + " 行所对应的数据： " + bRooms.getCode() + " 已存在于数据库\n ";
                        location++;
                        continue;
                    }
                    //判断当前excel是否有重复code
                    if(currentlyCode.contains(bRooms.getCode())){
                        errorDetail += "第 " + location + " 行所对应的数据： " + bRooms.getCode() + " 已存在于此Excel\n ";
                        location++;
                        continue;
                    }
                    //判断此行是否为空
                    if(bRooms.getCode() == null || bRooms.getCode().equals("") ){
                        if(bRooms.getCategory() == null || bRooms.getCategory().equals("")){
                            if(bRooms.getCampus() == null || bRooms.getCampus().equals("") ){
                                if(bRooms.getBuilding() == null || bRooms.getCampus().equals("") ){
                                    if(bRooms.getClassroomNo() == null || bRooms.getClassroomNo().equals("")){
                                        if(bRooms.getClassSeat() == null){
                                            location++;
                                            continue;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    //判断是否有空值
                    if (bRooms.getClassSeat() == null
                            || bRooms.getCode() == null || bRooms.getCategory() == null || bRooms.getCampus() == null
                            || bRooms.getBuilding() == null || bRooms.getClassroomNo() == null || bRooms.getCode().equals("") || bRooms.getCategory().equals("") || bRooms.getCampus().equals("")
                        || bRooms.getBuilding().equals("") || bRooms.getClassroomNo().equals("")){
                        errorDetail += "第 " + location + " 行所对应的数据有空数据\n ";
                        location++;
                        continue;
                    }
                    UserUtil.setCurrentPersistOperation(bRooms);
                    bRooms.setClassroomName(classroomName);
                    list.add(bRooms);
                    currentlyCode.add(bRooms.getCode());
                    //当前行数+1
                    location++;
                } //end of rows iterator


            } //end of sheets for loop

            //close file input stream
            fis.close();

        } catch (IOException e) {
            e.printStackTrace();
        }
        finalResult.put("list",list);
        finalResult.put("errorDetail",errorDetail);
        file.delete();
        return finalResult;
    }

}
