package org.rcisoft.business.brslstudent.service;


import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.brslstudent.entity.BRSlStudent;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;

import java.io.IOException;
import java.util.List;

/**
 * Created by CodeGenerator on 2017/07/12.
 */
public interface BRSlStudentService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BRSlStudent selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BRSlStudent> queryBRSlStudentsByPagination(PageUtil pageUtil, BRSlStudent model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BRSlStudent> queryBRSlStudents(BRSlStudent model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BRSlStudent model);

    /**
     * 学生选课信息excel导入
     * @param hwb
     * @return
     */
    PersistModel importExcel(HSSFWorkbook hwb) throws IOException;

    /**
     * 逻辑删除
     * @return
     */
    PersistModel removeBRSlStudents(String studentCode, String slCode);
}
