package org.rcisoft.business.brslstudent.service.impl;

import com.alibaba.fastjson.JSON;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.brslstudent.dao.BRSlStudentRepository;
import org.rcisoft.business.brslstudent.entity.BRSlStudent;
import org.rcisoft.business.brslstudent.service.BRSlStudentService;
import org.rcisoft.business.bsl.dao.BSlRepository;
import org.rcisoft.business.bsl.entity.BSl;
import org.rcisoft.business.bstudent.dao.BStudentRepository;
import org.rcisoft.business.bstudent.entity.BStudent;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.util.ExcelUtil;
import org.rcisoft.core.util.IdGen;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by CodeGenerator on 2017/07/12.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
public class BRSlStudentServiceImpl implements BRSlStudentService {
    @Autowired
    private BRSlStudentRepository bRSlStudentRepository;
    @Autowired
    private BStudentRepository bStudentRepository;
    @Autowired
    private BSlRepository bSlRepository;
    /*@Autowired
    private UserRepository userRepository;
    @Autowired
    private IAction action;*/
    @Autowired
    private Global global;

    @Override
    public BRSlStudent selectOne(String businessId){
        return bRSlStudentRepository.selectByPrimaryKey(businessId);
    }

    @Override
    public List<BRSlStudent> queryBRSlStudentsByPagination(PageUtil pageUtil, BRSlStudent model) {
        Map param = new HashMap<String,Object>();
        return bRSlStudentRepository.queryBRSlStudents(param);
    }

    @Override
    public List<BRSlStudent> queryBRSlStudents(BRSlStudent model) {
        Map param = new HashMap<String,Object>();
        return bRSlStudentRepository.queryBRSlStudents(param);
    }


    @Override
    public PersistModel persist(BRSlStudent model){
        int line = 0;
        if(model.getBusinessId()!=null)
            line = bRSlStudentRepository.updateByPrimaryKeySelective(model);
        else {
            model.setBusinessId(IdGen.uuid());
            line = bRSlStudentRepository.insertSelective(model);
        }
        //FamilyLogger.sysInfo(UserUtils.getUser().getBusinessId(),UserUtils.getUser().getLoginName()+"新增了ID为"+user.getBusinessId()+"的用户");
        return new PersistModel(line);
    }

    @Override
    public PersistModel importExcel(HSSFWorkbook hwb) throws IOException {
        ArrayList<BRSlStudent> brSlStudents = new ArrayList<BRSlStudent>();
        //List<BRSlStudent> repeatCode = new ArrayList<>();
        ArrayList<String> repeatCode = new ArrayList<>();
        ArrayList<String> slCode = new ArrayList<String>();
        ArrayList<String> studentCode = new ArrayList<String>();
        /*ArrayList<String> gitlabP = new ArrayList<String>();
        ArrayList<String> gitlabUser = new ArrayList<String>();*/
        String innerRepeatResult = "";
        List<String> currently = new ArrayList<>();
        String[] headers = {"课序号","学号"};
        ArrayList<String[]> values = ExcelUtil.importExcel(hwb,headers,false,1);  //获取excel数据


        if (values.size()<1){
            throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DATA_NOT_EXIST);
        }

        for(String[] value:values){   //将数据封装到entity
            //1.检查数据正确性
            BRSlStudent brSlStudent = null;
            BRSlStudent b = new BRSlStudent(value[1],value[0]);
            BSl bSl = null;
            if(value[0]==null||value[0].equals("")||value[1]==null||value[1].equals("")){
                continue;
            }
            if((bSl = bSlRepository.selectOne(new BSl(value[0])))==null) {
                if(!slCode.contains(value[0]))
                    slCode.add(value[0]);
                continue;
            }
            if((bStudentRepository.selectOne(new BStudent(value[1])))==null) {
                if(!studentCode.contains(value[1]))
                    studentCode.add(value[1]);
                continue;
            }
            if((brSlStudent=bRSlStudentRepository.queryBRSlStudentByCodes(b))!=null) {
                //repeatCode.add(brSlStudent);
                repeatCode.add("学号："+b.getStudentCode()+"；课序号："+b.getSlCode());
                continue;
            }

            /*if(bSl.getGitLabProjectId()==null){
                gitlabP.add(value[0]);
                continue;
            }*/

            //2.封装git lab信息
            /*User user = userRepository.selectOne(new User(value[1]));
            AccountDTO dto =  new AccountDTO(user.getGitLabId(),user.getGitLabImpressionToken());
            if(StringUtils.isEmpty(dto.getId())|| StringUtils.isEmpty(dto.getImpersonationToken())){
                gitlabUser.add(value[1]);
                continue;
            }
            User user1 = userRepository.selectOne(new User(bSl.getTeacherCode()));
            Branch branch = new Branch();
            branch.setBranch(global.getGIT_LAB_STU_PREFIX()+value[1]);
            branch.setRef(global.getGIT_LAB_DEFAUL_BRANCH());
            action.createBranch(
                    bSl.getGitLabProjectId(),
                    dto.getId(),
                    user1.getGitLabImpressionToken(),
                    branch);*/

            //3.封装学生选课信息
            brSlStudent= new BRSlStudent(value[1],value[0]);
            if(currently.contains(brSlStudent.toString())){
                innerRepeatResult += "课序号，学号分别为 " + value[0] + " " + value[1] + " 的数据，在Excel中重复出现，除第一条以外的数据插入失败 \n";
                continue;
            }
            currently.add(brSlStudent.toString());
            brSlStudent.setBusinessId(IdGen.uuid());
            if(!brSlStudents.contains(brSlStudent)){

                brSlStudents.add(brSlStudent);
            }
        }

        String result ="";

        if(brSlStudents.size()>0){
            int line = bRSlStudentRepository.insertList(brSlStudents);
            if (line>0){
                result  = "成功导入"+brSlStudents.size()+"条数据。";
            }else{
                throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DB_INSERT_ERROR);
            }
        }

        StringBuilder nullResult = new StringBuilder();
        if(repeatCode.size()>0){
            nullResult.append(" 以下选课关系已存在：").append(JSON.toJSONString(repeatCode)).append("。");
        }
        if(slCode.size()>0){
            nullResult.append(" 以下课序号不存在：").append(JSON.toJSONString(slCode)).append("。");
        }
        if(studentCode.size()>0){
            nullResult.append(" 以下学号不存在：").append(JSON.toJSONString(studentCode)).append("。");
        }
        /*if(gitlabP.size()>0){
            nullResult.append(" 以下课程gitlab信息不存在（请重试导入开课）: ").append(this.sub(JSON.toJSONString(gitlabP))).append("。");
        }
        if(gitlabUser.size()>0){
            nullResult.append(" 以下学生gitlab信息不存在（请稍后重试）: ").append(JSON.toJSONString(gitlabUser)).append("。");
        }*/
        result+=nullResult;
        if(brSlStudents.size()<1){
            throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DB_INSERT_ERROR.getCode(),result);
        }


        return new PersistModel(1,result+nullResult.toString() + innerRepeatResult);
    }

    static String sub(String str) {
        StringBuffer result = new StringBuffer();
        List list = new ArrayList();
        char[] cs = str.toCharArray();
        for(int i=0; i<cs.length; i++){
            if(!list.contains(cs[i])){
                result.append(cs[i]);
                list.add(cs[i]);
            }
        }
        return result.toString();
    }


    @Override
    public PersistModel removeBRSlStudents(String studentCode, String slCode) {
        BRSlStudent brSlStudent = new BRSlStudent(studentCode,slCode);
        int line = bRSlStudentRepository.delete(brSlStudent);
        return new PersistModel(line);
    }
}
