package org.rcisoft.business.bsl.service;


import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.bsl.dto.SlDTO;
import org.rcisoft.business.bsl.dto.SlDetailDTO;
import org.rcisoft.business.bsl.entity.BSl;
import org.rcisoft.business.bstudent.entity.BStudent;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;

/**
 * Created by CodeGenerator on 2017/07/12.
 */
public interface BSlService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BSl selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BSl> queryBSlsByPagination(PageUtil pageUtil, BSl model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BSl> queryBSls(BSl model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BSl model,String token) throws UnsupportedEncodingException;

    /**
     * 开课信息excel导入
     * @param hwb
     * @return
     */
    PersistModel importExcel(HSSFWorkbook hwb,String token) throws IOException;

    /**
     * 逻辑删除
     * @param id
     * @return
     */
    PersistModel removeBSl(String id);

    /**
     * 更新选课的操作
     */
//    PersistModel updateIsOnline(String lessonCode,String token);

    /**
     * 根据主键更新选课信息
     * @param bSl
     * @return
     */
    PersistModel updateBSlByPrimaryKey(BSl bSl, String token);

    /**
     * 根据学号查找学生学习课程
     * @return
     */
    List<SlDTO> queryStudentSLByCodeByPagination(PageUtil pageUtil, String studentCode, String lessonName, String termCode);

    /**
     * 根据教师工号查找在教课程
     * @param teacherCode
     * @return
     */
    List<SlDTO> queryTeacherSLByCodeByPagination(PageUtil pageUtil, String teacherCode, String lessonName, String auditStatus, String termCode);

    /**
     * 获取精品课程
     * @param pageUtil
     * @return
     */
    List<BSl> queryBSlWithRecommendByPagination(PageUtil pageUtil);

    /**
     * 获取课程详情
     * @param id
     * @return
     */
    SlDetailDTO querySlDetailDTOById(String id);

    /**
     * 根据学号和课序号查找课程
     * @param stuCode
     * @param slCode
     * @return
     */
    boolean stuHasSl(String stuCode, String slCode);

    /**
     * 根据教师工号和课序号查找课程
     * @param teaCode
     * @param slCode
     * @return
     */
    boolean teaHasSl(String teaCode, String slCode);

    int queryStuInLessionOrNot(String lessionCode, String studentCode);

    int queryBslTeacher(String teacherCode, String businessId);

    List<BSl> historySlByCodeByPagination(PageUtil pageUtil, String lessonName, String termCode, String studentCode, String teacherCode);

    int auditBsl(String slId, String status, String opinion);

    int updateTeacher(String businessId, String teacherCode);

    //List<BStudent> querySlStudentByPagination(PageUtil pageUtil, String slId);
}
