package org.rcisoft.business.bsl.service.impl;

import com.alibaba.fastjson.JSON;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.bchapter.service.BChapterService;
import org.rcisoft.business.bdirection.dao.BDirectionRepository;
import org.rcisoft.business.bdirection.entity.BDirection;
import org.rcisoft.business.blesson.dao.BLessonRepository;
import org.rcisoft.business.blesson.entity.BLesson;
import org.rcisoft.business.blesson.entity.BLessonDirection;
import org.rcisoft.business.bopinion.dao.BOpinionRepository;
import org.rcisoft.business.bopinion.entity.BOpinion;
import org.rcisoft.business.brslstudent.dao.BRSlStudentRepository;
import org.rcisoft.business.brslstudent.entity.BRSlStudent;
import org.rcisoft.business.bsl.dao.BSlRepository;
import org.rcisoft.business.bsl.dto.SlDTO;
import org.rcisoft.business.bsl.dto.SlDetailDTO;
import org.rcisoft.business.bsl.entity.BSl;
import org.rcisoft.business.bsl.enums.AuditStatusEnum;
import org.rcisoft.business.bsl.service.BSlService;
import org.rcisoft.business.bstudent.entity.BStudent;
import org.rcisoft.business.bteacher.dao.BTeacherRepository;
import org.rcisoft.business.bteacher.entity.BTeacher;
import org.rcisoft.business.bterm.dao.BTermRepository;
import org.rcisoft.business.bterm.entity.BTerm;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.util.ExcelUtil;
import org.rcisoft.core.util.IdGen;
import org.rcisoft.core.util.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.*;


/**
 * Created by CodeGenerator on 2017/07/12.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
public class BSlServiceImpl implements BSlService {
    @Autowired
    private BSlRepository bSlRepository;
    @Autowired
    private BTeacherRepository bTeacherRepository;
    @Autowired
    private BLessonRepository bLessonRepository;
    @Autowired
    private BTermRepository bTermRepository;
    @Autowired
    private BRSlStudentRepository brSlStudentRepository;
    @Autowired
    private BChapterService bChapterService;
    @Autowired
    private BDirectionRepository bDirectionRepository;

    @Autowired
    private BOpinionRepository bOpinionRepository;
    /*@Autowired
    private UserRepository userRepository;
    @Autowired
    private IAction action;*/
    @Autowired
    private Global global;

    @Override
    public BSl selectOne(String businessId){
        return bSlRepository.selectByPrimaryKey(businessId);
    }

    @Override
    public List<BSl> queryBSlsByPagination(PageUtil pageUtil, BSl model) {
        return bSlRepository.queryBSls(getParames(model));
    }

    @Override
    public List<BSl> queryBSls(BSl model) {

        return bSlRepository.queryBSls(getParames(model));
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel persist(BSl model,String token) throws UnsupportedEncodingException {
        int line = 0;
        BLessonDirection direction = new BLessonDirection();
        direction.setDirectionId(model.getDirectionId());
        if(model.getBusinessId()!=null){
            BSl bSl = bSlRepository.selectByPrimaryKey(model.getBusinessId());
            if(bSl==null)
                throw new ServiceException(ResultServiceEnums.SL_INFO_NOT_EXISTS);
            /*boolean isRecommend = model.getIsRecommend()!=null&&model.getIsRecommend().equals(RecommendEnum.RECOMMEND.getCode());
            boolean isOnline = bSl.getIsOnline().equals(BSlEnum.START.getCode());
            if(isRecommend&&!isOnline)
                throw new ServiceException(ResultServiceEnums.SL_NOT_ONLINE);*/

            UserUtil.setCurrentMergeOperation(model);
            line = bSlRepository.updateByPrimaryKeySelective(model);
            if(direction.getDirectionId()!=null){
                direction.setSlId(model.getBusinessId());
                bLessonRepository.updateDirectionBySlId(direction);
            }

        }
        else {
            String lecode = model.getLessonCode();
            BLesson bLesson = bLessonRepository.queryBLessonByCode(lecode);
            if(bLesson==null)
                throw new ServiceException(ResultServiceEnums.LESSON_NOT_EXISTA);
            model.setSlCoverUrl(bLesson.getDefaultUrl());

            if(bSlRepository.selectOne(new BSl(model.getCode()))!=null)
                throw new ServiceException(ResultServiceEnums.SL_EXISTS);
            //3. 封装git lab
            /*User user = userRepository.selectOne(new User(model.getTeacherCode()));
            AccountDTO dto =  new AccountDTO(user.getGitLabId(),user.getGitLabImpressionToken());
            dto.setUsername(user.getGitLabUsername());
            if(StringUtils.isEmpty(dto.getId())|| StringUtils.isEmpty(dto.getImpersonationToken())){
                throw new ServiceException(ResultServiceEnums.TEACHER_NOT_HAVA_GIT_LAB);
            }
            Project project = action.createProject(pName,dto);
            model.setGitLabProjectId(project.getId());*/
            String pName = "";
            model.setGitLabProjectName(pName);
            model.setAuditStatus("0");
            UserUtil.setCurrentPersistOperation(model);
            int data = bSlRepository.insertSelective(model);
            int result = bChapterService.addBslFormLesson(bLesson.getBusinessId(),model.getLessonCode(), model.getBusinessId());
            //添加课程方向信息
            direction.setBusinessId(IdGen.uuid());
            direction.setSlId(model.getBusinessId());
            direction.setDirectionId(model.getDirectionId());
            bLessonRepository.insertLessonDirection(direction);
            if(data!=0&&result!=0){
                line= data;
            }
        }
        //FamilyLogger.sysInfo(UserUtils.getUser().getBusinessId(),UserUtils.getUser().getLoginName()+"新增了ID为"+user.getBusinessId()+"的用户");
        return new PersistModel(line);
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel importExcel(HSSFWorkbook hwb,String token) throws IOException {
        ArrayList<BSl> bSls = new ArrayList<BSl>();
        ArrayList<String> repeatCode = new ArrayList<String>();
        ArrayList<String> lessonCode = new ArrayList<String>();
        ArrayList<String> teacherCode = new ArrayList<String>();
        ArrayList<String> termCode = new ArrayList<String>();
        List<String> currentlyCode = new ArrayList<>();
        String innerRepeatResult = "";
        //ArrayList<String> direction = new ArrayList<String>();
        //List<BSl> repeatSl = new ArrayList<>();
        Map map = new HashMap();

        String[] headers = {"课序号","课程编号","教师工号","学期编号"};
        ArrayList<String[]> values = ExcelUtil.importExcel(hwb,headers,false,1);  //获取excel数据

        if (values.size()<=0){
            throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DATA_NOT_EXIST);
        }

        for(String[] value:values){   //将数据封装到entity
            if(value.length>=4) {
                //1. 检查数据正确性
                BSl bSl = null;
                BSl b = new BSl(value[0]);
                /*BSl bSl1 = new BSl();
                bSl1.setTermCode(value[3]);
                bSl1.setTeacherCode(value[2]);
                bSl1.setLessonCode(value[1]);*/
                /*bSl1.setClassHour(value[4]);
                bSl1.setCredits(value[5]);
                bSl1.setDirectionId(value[6]);*/
                if (StringUtils.isAnyEmpty(value[0]) || value[1] == null || value[1].equals("")) {
                    continue;
                }
                if ((bSl = bSlRepository.selectOne(b)) != null) {
                    repeatCode.add(value[0]);
                    continue;
                }
                //
                if ((bTeacherRepository.selectOne(new BTeacher(value[2],"0","1"))) == null) {
                    if (!teacherCode.contains(value[2]))
                        teacherCode.add(value[2]);
                    continue;
                }
                if ((bLessonRepository.queryBLessonByCode(value[1])) == null) {
                    if (!lessonCode.contains(value[1]))
                        lessonCode.add(value[1]);
                    continue;
                }
                if ((bTermRepository.selectOne(new BTerm(value[3],null))) == null) {
                    if (!termCode.contains(value[3]))
                        termCode.add(value[3]);
                    continue;
                }
                /*if ((bDirectionRepository.selectOne(new BDirection(value[6]))) == null) {
                    if (!direction.contains(value[6]))
                        direction.add(value[6]);
                    continue;
                }*/
                /*if ( bSlRepository.selectOne(bSl1) != null) {
                    repeatSl.add(bSl1);
                    continue;
                }*/

                //2 封装BSL
                bSl = new BSl(value[0], value[1], value[2], value[3]);
                BLesson bLesson =  bLessonRepository.queryBLessonByCode(value[1]);
                bSl.setSlCoverUrl(bLesson.getDefaultUrl());
                bSl.setCredits(bLesson.getCredits());
                bSl.setClassHour(bLesson.getClassHour());
                if(currentlyCode.contains(bSl.getCode())){
                    innerRepeatResult += "编号 " + bSl.getCode() + " 在Excel中重复出现，除第一条以外的数据插入失败 \n";
                    continue;
                }
                currentlyCode.add(bSl.getCode());
                UserUtil.setCurrentPersistOperation(bSl);

                BLessonDirection bDirection = new BLessonDirection();


                if (!bSls.contains(bSl)) {

                    bSls.add(bSl);
                    bDirection.setDirectionId(bLesson.getDirectionId());
                    bDirection.setBusinessId(IdGen.uuid());
                    bDirection.setSlId(bSl.getBusinessId());
                    bDirectionRepository.insertBLessonDirection(bDirection);
                    map.put(bSl.getLessonCode(), bSl.getBusinessId());
                }

            }
        }
        String result ="";
        if(bSls.size()>0){
            int line = bSlRepository.insertList(bSls);
            if (line>0){
                for (int i=0;i<bSls.size();i++){
                    bChapterService.addBslFormLesson(null,bSls.get(i).getLessonCode(), String.valueOf(map.get(bSls.get(i).getLessonCode())));
                }
                result  = "成功导入"+bSls.size()+"条数据。";
            }else{
                throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DB_INSERT_ERROR);
            }
        }

        StringBuilder nullResult = new StringBuilder();
        /*if(repeatSl.size()>0){
            nullResult.append("以下开课记录已存在：").append(JSON.toJSONString(repeatSl)).append("。 ");
        }*/
        if(repeatCode.size()>0){
            nullResult.append("以下课序号已存在：").append(JSON.toJSONString(repeatCode)).append("。 ");
        }
        if(lessonCode.size()>0){
            nullResult.append("以下课程编号不存在：").append(JSON.toJSONString(lessonCode)).append("。 ");
        }
        if(teacherCode.size()>0){
            nullResult.append("以下教师工号不存在：").append(JSON.toJSONString(teacherCode)).append("。 ");
        }
        if(termCode.size()>0){
            nullResult.append("以下学期编号不存在：").append(JSON.toJSONString(termCode)).append("。 ");
        }
        /*if(termCode.size()>0){
            nullResult.append("以下课程方向编号不存在：").append(JSON.toJSONString(direction)).append("。 ");
        }*/
        result+=nullResult;
        if(bSls.size()<1){
            throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DB_INSERT_ERROR.getCode(),result);
        }
        return new PersistModel(1,result + innerRepeatResult);
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel removeBSl(String id) {
        BSl bSl = bSlRepository.selectByPrimaryKey(id);
        if(bSl==null)
            throw new ServiceException(ResultServiceEnums.SL_INFO_NOT_EXISTS);
        //action.deleteProject(bSl.getGitLabProjectId());
        brSlStudentRepository.deleteBatch(bSl.getCode());
        BSl bsl = new BSl();
        bsl.setBusinessId(id);
        UserUtil.setCurrentMergeOperation(bsl);
        bSl.setDeleted();
        int line = bSlRepository.logicalDelete(bSl);
        //int line = bSlRepository.deleteByPrimaryKey(id);
        return new PersistModel(line);
    }

    /*@Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel updateIsOnline(String lessonCode,String token) {
        BSl bSl = new BSl();
        bSl.setCode(lessonCode);
        BSl one = bSlRepository.selectOne(bSl);
        if(one==null)
            throw new ServiceException(ResultServiceEnums.SL_INFO_NOT_EXISTS);
        if(one.getIsOnline().equals(BSlEnum.START.getCode()))
            one.setIsOnline(BSlEnum.UN_START.getCode());
        else
            one.setIsOnline(BSlEnum.START.getCode());
        UserUtil.setCurrentMergeOperation(one);
        int result = bSlRepository.updateByPrimaryKeySelective(one);
        return new PersistModel(result);
    }*/

    @Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel updateBSlByPrimaryKey(BSl bSl, String token) {
        UserUtil.setCurrentMergeOperation(bSl);
        int line = bSlRepository.updateByPrimaryKeySelective(bSl);
        return new PersistModel(line);
    }

    @Override
    public List<SlDTO> queryStudentSLByCodeByPagination(PageUtil pageUtil, String studentCode, String lessonName, String termCode) {
        return bSlRepository.selectStudentSLByCode(studentCode,lessonName,termCode);
    }

    @Override
    public List<SlDTO> queryTeacherSLByCodeByPagination(PageUtil pageUtil, String teacherCode, String lessonName, String auditStatus, String termCode) {
        return bSlRepository.selectTeacherSLByCode(teacherCode,lessonName, auditStatus, termCode);
    }

    @Override
    public List<BSl> queryBSlWithRecommendByPagination(PageUtil pageUtil) {
        return bSlRepository.queryBSlsWithRecommend();
    }

    @Override
    public SlDetailDTO querySlDetailDTOById(String id) {
        return bSlRepository.selectSlDetailDTOById(id);
    }

    @Override
    public boolean stuHasSl(String stuCode, String slCode) {
        BRSlStudent brSlStudent = new BRSlStudent();
        brSlStudent.setSlCode(slCode);
        brSlStudent.setStudentCode(stuCode);
        return brSlStudentRepository.selectOne(brSlStudent)!=null;
    }

    @Override
    public boolean teaHasSl(String teaCode, String slCode) {
        BSl bSl = new BSl();
        bSl.setCode(slCode);bSl.setTeacherCode(teaCode);
        return bSlRepository.selectOne(bSl)!=null;
    }

    @Override
    public int queryStuInLessionOrNot(String selectCode, String studentCode) {
        int result = bSlRepository.queryStuInLessionOrNot(studentCode,selectCode);
        return result;
    }

    @Override
    public int queryBslTeacher(String teacherCode, String businessId) {
        return bSlRepository.queryBslTeacher(teacherCode,businessId);
    }

    @Override
    public List<BSl> historySlByCodeByPagination(PageUtil pageUtil, String lessonName, String termCode, String studentCode, String teacherCode) {
        return bSlRepository.historySlByCodeByPagination(lessonName,termCode,studentCode,teacherCode);
    }

    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    @Override
    public int auditBsl(String slId, String status, String opinion) {
        int result = 0;
        if(status.equals(AuditStatusEnum.AUDITING.getCode())) {//提交审核
            result = bSlRepository.updateAuditStatus(slId,AuditStatusEnum.AUDITING.getCode());
        }else if(status.equals(AuditStatusEnum.PUBLISHED.getCode())) {//通过
            result = bSlRepository.updateAuditStatus(slId, AuditStatusEnum.PUBLISHED.getCode());
        }else if(status.equals(AuditStatusEnum.DISMISSAL.getCode())) {//驳回  记录驳回意见
            BOpinion bOpinion = new BOpinion();
            bOpinion.setBusinessId(IdGen.uuid());
            bOpinion.setCreateDate(new Date());
            bOpinion.setOpinion(opinion);
            bOpinion.setSlId(slId);
            bOpinionRepository.insert(bOpinion);
            result = bSlRepository.updateAuditStatus(slId, AuditStatusEnum.DISMISSAL.getCode());
        }else if(status.equals(AuditStatusEnum.END_LESSON.getCode())) {//结课
            result = bSlRepository.updateAuditStatus(slId, AuditStatusEnum.END_LESSON.getCode());
        }else{//待发布
            result = bSlRepository.updateAuditStatus(slId, AuditStatusEnum.WAIT_RELEASE.getCode());
        }
        return result;
    }

    @Override
    public int updateTeacher(String businessId, String teacherCode) {
        return bSlRepository.updateTeacher(businessId,teacherCode);
    }

    /*@Override
    public List<BStudent> querySlStudentByPagination(PageUtil pageUtil, String slId) {
        return bSlRepository.querySlStudentByPagination(slId);
    }*/


    private Map<String,Object> getParames(BSl model){
        Map param = new HashMap<String,Object>();
        param.put("lessonName", model.getLessonName());
        param.put("teacherName",model.getTeacherName());
        //param.put("isOnline", model.getIsOnline());
        param.put("termCode", model.getTermCode());
        param.put("auditStatus", model.getAuditStatus());
        return param;
    }

    private String paramHandler(String param){
        return "%"+param+"%";
    }

}
