package org.rcisoft.business.bsl.task;

import com.itextpdf.text.pdf.PdfReader;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.util.CutPdfUtil;
import org.rcisoft.core.util.OfficeToPdf;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import java.io.File;

/**
 * Created by lcy on 18/1/25.
 */
@Component
@Slf4j
public class SlTask {

    @Autowired
    private OfficeToPdf officeToPdf;

    @Autowired
    private CutPdfUtil cutPdfUtil;

    @Autowired
    private Global global;

    @Async
    public void officeToPdf(String sourceFile, String destFile){
        officeToPdf.transformToPdf(sourceFile,destFile);
    }


    @Async
    public void cutPdf(String newPath,String fileName, String uploadFileName) throws Exception{
        int i = 0;
        int j = 1;
        boolean finish = false;
        String filePath = global.getBASE_UPLOAD_SERVER_LOCATION() + File.separator
                + newPath+ fileName;
        String newFile = global.getBASE_UPLOAD_SERVER_LOCATION() + File.separator
                + newPath + global.getCUT_PDF_LOCATION() + File.separator;
        File file = new File(newFile);
        if(!file.exists()){
            file.mkdirs();
        }
        PdfReader reader = new PdfReader(filePath);
        int pageNum = reader.getNumberOfPages();
        if(pageNum>global.getCUT_PDF_NUM()){
            do{
                String outPutFile =  newFile + uploadFileName + j +".pdf";
                int end = i+global.getCUT_PDF_NUM();
                if(end>=pageNum){
                    end = pageNum;
                    finish = true;
                }
                cutPdfUtil.partitionPdfFile(reader,outPutFile,i+1,end);
                i+=global.getCUT_PDF_NUM();
                j++;
            }while (!finish);
        }

        reader.close();
    }
}
