package org.rcisoft.business.bslapply.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Calendar;
import java.util.Random;

/**
* Created with gwf on 2017-8-10 11:05:34.
*/
@Entity
@Table(name = "b_sl_apply")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BSlApply extends IdEntity<BSlApply> {

    public BSlApply(String applyCode) {
        this.applyCode = applyCode;
    }


    /*学期标号*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
    private String termCode;
    /*课程名称*/
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    private String slName;
    /*申请理由*/
    private String applyCourse;
    /*0申请中，1已通过，2已打回*/
    private String applyState;
    /*申请单号*/
    @Length(min = 1,max = 32,message = "长度最小为1,最大为30")
    @NotBlank
    private String applyCode;
    /*教师编号*/
    @Length(min = 1,max = 32,message = "长度最小为1,最大为30")
    @NotBlank
    private String teacherCode;
    /*拒绝原因*/
    @Length(min = 1,max = 200,message = "长度最小为1,最大为150")
    private String refuseCourse;

    @Transient
    private String teacherName;

    public void autoSetApplyCode(){
        Calendar calendar = Calendar.getInstance();
        StringBuilder applyCode = new StringBuilder();
        Random random = new Random();
        String month = "";
        int canMonth = calendar.get(Calendar.MONTH);
        if(canMonth<9)
            month = "0"+(canMonth+1);
        else if(canMonth==9)
            month = "10";
        else
            month = String.valueOf(month+1);
        applyCode
                .append(calendar.get(Calendar.YEAR))
                .append(month)
                .append(calendar.get(Calendar.DATE))
                .append(calendar.get(Calendar.HOUR))
                .append(calendar.get(Calendar.MINUTE))
                .append(calendar.get(Calendar.SECOND))
                .append(random.nextInt(1000));
        this.setApplyCode(applyCode.toString());
    }

}

