package org.rcisoft.business.bslschedule.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.beduclass.entity.BEduClass;
import org.rcisoft.business.bslschedule.entity.BSlSchedule;
import org.rcisoft.business.bslschedule.entity.ScheduleDetail;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
* Created with  on 2018-5-2 16:39:34.
*/
@Repository
public interface BSlScheduleRepository extends BaseMapper<BSlSchedule> {

    /**
    * 分页查询 bSlSchedule
    *
    */
    @Select("<script>select * from b_sl_schedule where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BSlSchedule> queryBSlSchedules(BSlSchedule bSlSchedule);

    @Select("<script>select *, s_user.name as teacherName,b_lesson.class_hour as classHour,"
            + "b_agency.name as agencyName,b_agency.code as agencyCode,b_agency.business_id as agencyId, \n"
            + "b_lesson.code as lessonCode,b_direction.name as directionName,b_direction.code as directionCode, \n"
            + "b_sl.code as bslCode, \n"
            + "(select sum(student_num) from b_class where FIND_IN_SET(b_class.code,b_edu_class.classes_id)) AS studentNum from b_sl_schedule "
            + "left join b_sl on b_sl_schedule.tea_code = b_sl.teacher_code and b_sl_schedule.term_code = b_sl.term_code and b_sl_schedule.lesson_code = b_sl.lesson_code \n"
            + "left join b_edu_class on b_edu_class.code = b_sl_schedule.edu_class_code \n"
            + "left join b_lesson on b_lesson.code = b_sl_schedule.lesson_code \n"
            + "left join b_lesson_direction on b_lesson_direction.lession_id = b_lesson.business_id \n"
            + "left join b_direction on b_direction.business_id = b_lesson_direction.direction_id \n"
            + "left join b_rooms on b_rooms.code = b_sl_schedule.room_code \n"
            + "left join s_user on s_user.login_name = b_sl_schedule.tea_code \n"
            + "left join b_teacher on b_teacher.code = b_sl_schedule.tea_code \n"
            + "left join b_agency on b_agency.code = b_teacher.agency_code \n"
            + "where start_day between #{0} and #{1} and sub_agency_id = #{2} order by edu_class_code,start_day,seq"
            + "</script>"
    )
    @ResultMap(value = "BaseResultMap2" )
    List<BSlSchedule> queryMoreBSlSchedules(String minTime,String maxTime,String subAgencyId);

    int insertList(List<BSlSchedule> bSlSchedules);

    @Update("update b_sl_schedule set sl_id = #{slId} where sub_agency_id = #{subAgencyId} and del_flag = 0 and flag = 1")
    int updateSlIdBySubAgencyId(@Param("slId") String slId, @Param("subAgencyId") String subAgencyId);

    @Delete("delete from b_sl_schedule where sub_agency_id = #{subAgencyId}")
    int avoidRepeatBSlSchedule(String subAgencyId);

    @Update("update b_sl_schedule set status = #{status} where sub_agency_id = #{subAgencyId} and del_flag = 0 and flag = 1")
    int updateStatusBySubAgencyId(@Param("subAgencyId") String subAgencyId, @Param("status") String status);

    int countStudentNum(String classesId);

    @Select("select count(*) from b_sl_schedule where room_code = ( select `code` from b_rooms where business_id = #{businessId})")
    int countThisRoomNum(String businessId);

    @Select("select count(*) from b_sl_schedule bs " +
            "left join b_teacher bt on bs.tea_code = bt.code " +
            "where bt.business_id = #{id}")
    int querySlScheduleByTeaCode(String id);

    @Select("select count(*) from b_schedule_dto bs " +
            "left join b_teacher bt on bs.teacher_code = bt.code " +
            "where bt.business_id = #{id}")
    int querySlScheduleDtoByTeaCode(String id);

    @Select("SELECT\n" +
            "\tb_sl_schedule.room_code as roomCode,\n" +
            "\tb_sl_schedule.term_code as termCode,\n" +
            "\tb_sl_schedule.tea_code as teaCode,\n" +
            "\tb_sl_schedule.lesson_code as lessonCode,\n" +
            "\tb_sl_schedule.edu_class_code as eduClassCode,\n" +
            "\tb_sl_schedule.sub_agency_id as subAgencyId,\n" +
            "\t(\n" +
            "\t\tSELECT\n" +
            "\t\t\tsum(student_num)\n" +
            "\t\tFROM\n" +
            "\t\t\tb_class\n" +
            "\t\tWHERE\n" +
            "\t\t\tFIND_IN_SET(\n" +
            "\t\t\t\tb_class. CODE,\n" +
            "\t\t\t\tb_edu_class.classes_id\n" +
            "\t\t\t)\n" +
            "\t) AS studentNum,\n" +
            "\tb_lesson.lesson_name as lessonCode,\n" +
            "\tb_sl.`code` AS bslCode,\n" +
            "\tb_lesson.class_hour as classHour,\n" +
            "\ts_user.`name` AS userName,\n" +
            "\ts_user.email,\n" +
            "\ts_user.phone,\n" +
            "\tb_agency.`name` AS agencyName,\n" +
            "\tb_agency.`code` AS agencyCode,\n" +
            "\tb_rooms.campus,\n" +
            "\tb_rooms.category,\n" +
            "\tb_rooms.building,\n" +
            "\tb_rooms.classroom_no as classroomNo,\n" +
            "\tb_rooms.classroom_name as classroomName,\n" +
            "\tb_direction.name as directionName,\n" +
            "\tb_direction.code as directionCode\n" +
            "FROM\n" +
            "\tb_sl_schedule\n" +
            "LEFT JOIN b_rooms ON b_rooms.`code` = b_sl_schedule.room_code\n" +
            "LEFT JOIN b_term ON b_term.`code` = b_sl_schedule.term_code\n" +
            "LEFT JOIN b_lesson ON b_lesson.`code` = b_sl_schedule.lesson_code\n" +
            "LEFT JOIN b_lesson_direction ON b_lesson_direction.lession_id = b_lesson.business_id\n" +
            "LEFT JOIN b_direction ON b_direction.business_id = b_lesson_direction.direction_id\n" +
            "LEFT JOIN b_edu_class ON b_edu_class. CODE = b_sl_schedule.edu_class_code\n" +
            "LEFT JOIN s_user ON s_user.login_name = b_sl_schedule.tea_code\n" +
            "LEFT JOIN b_teacher ON b_teacher. CODE = b_sl_schedule.tea_code\n" +
            "LEFT JOIN b_agency ON b_agency. CODE = b_teacher.agency_code\n" +
            "LEFT JOIN b_sl ON b_sl_schedule.tea_code = b_sl.teacher_code\n" +
            "AND b_sl_schedule.term_code = b_sl.term_code\n" +
            "AND b_sl_schedule.lesson_code = b_sl.lesson_code\n" +
            "WHERE\n" +
            "b_rooms.flag = \"1\" and b_rooms.del_flag = \"0\" and\n" +
            "\tb_term.flag = \"1\" and b_term.del_flag = \"0\" and\n" +
            "\tb_lesson.flag = \"1\" and b_lesson.del_flag = \"0\" and\n" +
            "b_direction.flag = \"1\" and b_direction.del_flag = \"0\" and\n" +
            "b_edu_class.flag = \"1\" and b_edu_class.del_flag = \"0\" and\n" +
            "s_user.flag = \"1\" and s_user.del_flag = \"0\" and\n" +
            "b_agency.flag = \"1\" and b_agency.del_flag = \"0\" and\n" +
            "b_teacher.flag = \"1\" and b_teacher.del_flag = \"0\" and " +
            "\tb_sl_schedule.business_id = #{businessId}")
    @ResultMap(value = "DetailResultMap")
    ScheduleDetail queryDetail(String businessId);

    @Select("select DISTINCT(edu_class_code) as `code`,b_edu_class.class_name as className from b_sl_schedule LEFT JOIN b_edu_class on edu_class_code = b_edu_class.`code` \n" +
            "where sub_agency_id = #{2} and b_edu_class.flag = \"1\" and b_edu_class.del_flag = \"0\" ORDER BY edu_class_code")
    List<BEduClass> getAllEduClass(String minTime, String maxTime, String subAgencyId);

    @Select("select DISTINCT(edu_class_code) from b_sl_schedule \n" +
            "where sub_agency_id = #{2} ORDER BY edu_class_code")
    List<String> getNumOfEduClass(String minTime, String maxTime, String subAgencyId);
}

