package org.rcisoft.business.bslschedule.entity;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

@Data
@JsonSerialize(include= JsonSerialize.Inclusion.NON_EMPTY)
public class BSLData {

    @Data
    class InnerObject{
        String index;
        String tag;
        InnerObject(String index,String tag){
            this.index = index;
            this.tag = tag;
        }
    }

    @Data
    class Detail{
        List<InnerObject> innerObjectList = new ArrayList<>();
    }

    private Detail classes = new Detail();

    private Detail section = new Detail();

    private Detail mon = new Detail();

    private Detail tue = new Detail();

    private Detail wed = new Detail();

    private Detail thu = new Detail();

    private Detail fri = new Detail();

    private Detail sat = new Detail();

    private Detail sun = new Detail();

    public void addDetail(String index,String tag,String flag){
        switch (flag){
            case "classes":
                classes.innerObjectList.add(new InnerObject(index,tag));
                break;
            case "section":
                section.innerObjectList.add(new InnerObject(index,tag));
                break;
        }
    }

    public void addDetail(String index,String tag,int flag){
        switch (flag){
            case Calendar.MONDAY:
                mon.innerObjectList.add(new InnerObject(index,tag));
                break;
            case Calendar.TUESDAY:
                tue.innerObjectList.add(new InnerObject(index,tag));
                break;
            case Calendar.WEDNESDAY:
                wed.innerObjectList.add(new InnerObject(index,tag));
                break;
            case Calendar.THURSDAY:
                thu.innerObjectList.add(new InnerObject(index,tag));
                break;
            case Calendar.FRIDAY:
                fri.innerObjectList.add(new InnerObject(index,tag));
                break;
            case Calendar.SATURDAY:
                sat.innerObjectList.add(new InnerObject(index,tag));
                break;
            case Calendar.SUNDAY:
                sun.innerObjectList.add(new InnerObject(index,tag));
                break;
        }
    }

    public boolean hasClasses(){
        return this.classes.innerObjectList.size() != 0;
    }
    public boolean hasSection(){
        return this.section.innerObjectList.size() != 0;
    }
}
