package org.rcisoft.business.bteacher.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bteacher.entity.BTeacher;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with CodeGenerator on .
*/
@Repository
public interface BTeacherRepository extends BaseMapper<BTeacher> {

    /**
    * 根据条件查找
    * @param model
    * @return
    */
    @Select("<script>SELECT b.`business_id`,b.`is_recommend`,b.`recommend_date`,b.`recommend_order`,b.`recommend_course`,b.`code`,\n" +
            "b.create_by,b.create_date,b.del_flag,b.flag,b.remarks,b.update_by,b.update_date,u.`name`,u.email,\n" +
            "u.phone,u.sex,u.head_pic,b.agency_code,ba.`name` as agencyName\n" +
            "FROM b_teacher b\n" +
            "LEFT JOIN s_user u ON b.`code` = u.login_name\n" +
            "LEFT JOIN b_agency ba ON b.agency_code = ba.`code`\n" +
            "where b.del_flag != 1" +
            "<if test=\"condition != null and condition != ''\">and u.`name` like CONCAT('%',#{condition},'%') or b.`code` like CONCAT('%',#{condition},'%')</if>"+
            "<if test=\"teacherCode!=null\">and b.`code` != #{teacherCode}</if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTeacher> queryBTeachers(BTeacher model);

    @Insert("<script>INSERT INTO b_teacher" +
            "(create_date,update_date,create_by,update_by,remarks,del_flag,flag,business_id,code,agency_code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.createBy},#{item.updateBy},#{item.remarks},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code},#{item.agencyCode})" +
            "</foreach></script>")
    int insertList(List<BTeacher> bTeachers);

    @Select("<script>SELECT\n" +
            "\tb.`business_id`,\n" +
            "\tb.`code`,\n" +
            "\tb.`is_recommend`,\n" +
            "\tb.`recommend_date`,\n" +
            "\tb.`recommend_order`,\n" +
            "\tb.`recommend_course`,\n" +
            "\tb.create_by,\n" +
            "\tb.create_date,\n" +
            "\tb.del_flag,\n" +
            "\tb.flag,\n" +
            "\tb.remarks,\n" +
            "\tb.update_by,\n" +
            "\tb.update_date,\n" +
            "\tu.`name`,\n" +
            "\tu.email,\n" +
            "\tu.phone,\n" +
            "\tu.sex,\n" +
            "\tu.head_pic\n" +
            "FROM\n" +
            "\tb_teacher b\n" +
            "LEFT JOIN s_user u ON b.`code` = u.login_name\n" +
            "where b.del_flag = '0' " +
            "and b.flag = '1' "+
            "and b.is_recommend = '1' "+
            "order by b.recommend_order asc" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTeacher> queryTeacherWithReCommend();

    @Select("SELECT name,teacher_code from b_schedule_dto " +
            "left JOIN s_user on b_schedule_dto.teacher_code = s_user.login_name where sub_agency_id = #{subAgencyId} GROUP BY `name` ")
    @ResultMap(value = "SmallBaseResultMap" )
    List<BTeacher> selectTeacherBySubAgencyId(String subAgencyId);

    @Select("SELECT * from b_teacher where agency_code = #{agencyCode} and del_flag = 0 and flag = 1")
    @ResultMap(value = "BaseResultMap" )
    List<BTeacher> selectByAgencyCode(BTeacher bTeacher);


    int batchDeleteBycode(List<BTeacher> teacherList);

}

