package org.rcisoft.business.bteacher.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
* Created with CodeGenerator on .
*/
@Entity
@Table(name = "b_teacher")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BTeacher extends IdEntity<BTeacher> {
    private static final long serialVersionUID = -4023201651225813372L;


    public BTeacher(String code, String delFlag, String flag) {
        this.code = code;
        this.delFlag = delFlag;
        this.flag = flag;
    }


    /*教师工号*/
    @Length(min = 1,max = 11,message = "长度最小为1,最大为11")
    private String code;

    /*0:未推荐，1:推荐*/
    private String isRecommend;
    /*推荐时间，排序依据*/
    private Date recommendDate;
    /*推荐排序*/
    private Integer recommendOrder;
    /*推荐原因*/
    @Length(min = 1,max = 256,message = "长度最小为1,最大为200")
    @NotBlank
    private String recommendCourse;

    /*所属教学单位*/
    private String agencyCode;

    @Transient
    @Length(min = 1,max = 15,message = "长度最小为1,最大为15")
    private String name;

    @Transient
    private String sex;

    @Transient
    @Length(min = 1,max = 20,message = "长度最小为1,最大为20")
    private String email;

    @Transient
    private String phone;

    @Transient
    private String headPic;

    @Transient
    private String teacherCode;

    @Transient
    private String agencyName;

    @Transient
    private String condition;//模糊查询条件

    public BTeacher(String code, String agencyCode) {
        this.code = code;
        this.agencyCode = agencyCode;
    }

    public BTeacher(String code) {
        this.code = code;
    }
}

