package org.rcisoft.business.bteacher.service;


import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.bteacher.entity.BTeacher;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.user.entity.SysUser;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.List;

/**
 * Created by CodeGenerator on 2017/07/12.
 */
public interface BTeacherService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BTeacher selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BTeacher> queryBTeachersByPagination(PageUtil pageUtil, BTeacher model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BTeacher> queryBTeachers(BTeacher model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BTeacher model, SysUser user, String token) throws UnsupportedEncodingException;

    /**
     * 教师信息excel导入
     * @param hwb
     * @return
     */
    PersistModel importExcel(HSSFWorkbook hwb, String token) throws IOException, InterruptedException;

    /**
     * 逻辑删除
     * @param id
     * @return
     */
    PersistModel removeBTeacher(String id);

    /**
     *
     * @param pageUtil
     * @return
     */
    List<BTeacher> queryTeachersWithRecommendByPagination(PageUtil pageUtil);


}
