package org.rcisoft.business.bterm.dao;


import org.apache.ibatis.annotations.*;
import org.rcisoft.business.bterm.entity.BTerm;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.security.access.method.P;
import org.springframework.stereotype.Repository;

import java.text.DateFormat;
import java.util.Date;
import java.util.Map;
import java.util.List;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Repository
public interface BTermRepository extends BaseMapper<BTerm> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>select * from b_term where del_flag != 1 and flag = 1 ORDER BY start_date DESC</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBTerms(Map<String, Object> param);

    @Update("<script>update b_term set is_start=0 where business_id != #{id}</script>")
    int updateUnStart(String id);

    @Select("<script>select * from b_term where code = #{code}  and del_flag != 1 and flag = 1</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBtermByCode(String code);

    @Select("<script>select * from b_term " +
            "where del_flag != 1 " +
            "<if test=\"flag !=null and flag = '' \">and flag = 1 </if>" +
            "order by " +
            "<if test=\"current !=null and current = '1' \">current desc, </if>" +
            "start_date DESC</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBTermList(@Param("current") String current, @Param("flag") String flag);

    @Update("<script>update b_term set current = '0'</script>")
    int changeAllTermNotCurrent();

    @Update("<script>update b_term set current = '1' where code = #{code} and del_flag = 0 and flag = 1</script>")
    int changeCurrent(String code);

    @Select("select max_sl_code from b_term where code = #{termCode}")
    int queryMaxSlCodeByTermCode(String termCode);

    @Update("update b_term set max_sl_code = #{maxSlCode} where code = #{termCode} ")
    int MaxSlCodeByTermCode(@Param("termCode") String termCode,@Param("maxSlCode") String maxSlCode);


    /*
    这里可以不写，因为这个写的是  导入excel文件格式的时候的 插入，不是正常单个插入
    @Insert("<script>INSERT INTO b_teacher" +
            "(create_date,update_date,create_by,update_by,remarks,del_flag,flag,business_id,code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.createBy},#{item.updateBy},#{item.remarks},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code})" +
            "</foreach></script>")
    int insertList(List<BTeacher> bTeachers);
    */

    @Select("select * from b_term where code = #{termCode}")
    @ResultMap(value = "BaseResultMap" )
    BTerm queryCurrentTerm(String termCode);

    @Select("<script>select * from b_term " +
            "WHERE ((#{startDate} BETWEEN start_date AND end_date) " +
            "OR (#{endDate} BETWEEN start_date AND end_date) " +
            "OR (start_date BETWEEN #{startDate} AND #{endDate}) " +
            "OR (end_date BETWEEN #{startDate} AND #{endDate})) " +
            "<if test=\"businessId !=null and businessId != '' \">and business_id != #{businessId} </if>" +
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryBTermsByStartDateOrEndDate(BTerm model);

    @Select("<script>SELECT * FROM b_term bt \n" +
            "LEFT JOIN b_arrange ba ON bt.`code` = ba.term_code WHERE ba.term_code is NULL " +
            "<if test=\"current !=null and current = '1' \">order by bt.current desc </if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BTerm> queryTermNotInArrange(@Param("current") String currentt);
}

