package org.rcisoft.business.bterm.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import java.util.Date;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Entity
@Table(name = "b_term")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BTerm extends IdEntity<BTerm> {

    private static final long serialVersionUID = 6619306545135522432L;

    public BTerm(String code, String name) {
        this.code = code;
        this.name = name;
    }


    /*学期开始时间*/
    @NotBlank
    @NotNull
    private Date startDate;
    /*学期结束时间*/
    @NotBlank
    @NotNull
    private Date endDate;
    /*是否启动(0：未启动，1：启动)*/
    private String isStart;
    /*学期编号*/
    @NotBlank
    @Length(min = 1,max = 15,message = "长度最小为1,最大为15")
    private String code;
    /*学期名称*/
    @NotBlank
    @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
    private String name;

    /*是否是当前学期*/
    private String current;

    private String week;

    private Integer maxSlCode;

}

