package org.rcisoft.business.bterm.utils;


import java.text.SimpleDateFormat;
import java.util.*;

public class Week {

    private int weekNumber;

    private Date startDate;

    private Date endDate;

    public Week() {
    }

    public Week(int weekNumber, Date startDate, Date endDate) {
        this.weekNumber = weekNumber;
        this.startDate = startDate;
        this.endDate = endDate;
    }

    public int getWeekNumber() {
        return weekNumber;
    }

    public void setWeekNumber(int weekNumber) {
        this.weekNumber = weekNumber;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    //通过开始时间与计算时间计算周数与具体信息
    public static Map<String,Object> buildWeek(Date startDate1,Date endDate1){
        Map<String,Object> map = new HashMap<>();
        int currentlyWeek = 0;
        //声明数组
        List<Week> weeks = new ArrayList<>();
        Integer weekNumber = 1;
        //保存学期结束时间，方便以后进行比较
        Calendar termEndDate = Calendar.getInstance();
        termEndDate.setTime(endDate1);
        //结束时间 +1 方便计算
        //termEndDate.add(Calendar.DATE,1);
        //周开始时间
        Calendar startDate = Calendar.getInstance();
        startDate.setTime(startDate1);
        //判断第一天为星期几， 1为星期日，2为星期一，………………
        int dayOfWeek = startDate.get(Calendar.DAY_OF_WEEK);
        //周结束时间
        Calendar endDate = Calendar.getInstance();
        endDate.setTime(startDate1);
        //周结束时间为周开始时间直到周日
        endDate.add(Calendar.DATE,8-dayOfWeek);
        //当前时间
        Calendar currenlyTime = Calendar.getInstance();
        //如果第一周并不是完整的一周，则预先存入数组
        if(dayOfWeek != 2){
            Week week = new Week();
            week.setWeekNumber(weekNumber);
            week.setStartDate(startDate.getTime());
            week.setEndDate(endDate.getTime());
            //判断是否为当前周
            if((startDate.getTime().before(currenlyTime.getTime()) || startDate.getTime().equals(currenlyTime.getTime()))
                    &&
                    (endDate.getTime().after(currenlyTime.getTime()) || endDate.getTime().equals(currenlyTime.getTime()))){
                currentlyWeek = week.getWeekNumber();
            }
            weeks.add(week);
            //为下次循环做准备，周数加一，开始时间与结束时间 +7
            weekNumber += 1;
            //将时间调整为正常数据
            startDate.setTime(endDate.getTime());
            startDate.add(Calendar.DATE,1);
            endDate.add(Calendar.DATE,7);
        }

        //判断是否超出时间范围
        while(startDate.before(termEndDate) || startDate.equals(termEndDate)){
            //创建周实例
            Week week = new Week();
            //将该周的周数，开始时间，结束时间填入
            //if-else 判断最后一周是否为完整的一周
            if(endDate.equals(termEndDate) || endDate.before(termEndDate)){
                week.setWeekNumber(weekNumber);
                week.setStartDate(startDate.getTime());
                week.setEndDate(endDate.getTime());
                //判断是否为当前周
                if((startDate.getTime().before(currenlyTime.getTime()) || startDate.getTime().equals(currenlyTime.getTime()))
                        &&
                        (endDate.getTime().after(currenlyTime.getTime()) || endDate.getTime().equals(currenlyTime.getTime()))){
                    currentlyWeek = week.getWeekNumber();
                }
                weeks.add(week);
            }else{
                week.setWeekNumber(weekNumber);
                week.setStartDate(startDate.getTime());
                week.setEndDate(termEndDate.getTime());
                //判断是否为当前周
                if((startDate.getTime().before(currenlyTime.getTime()) || startDate.getTime().equals(currenlyTime.getTime()))
                        &&
                        (endDate.getTime().after(currenlyTime.getTime()) || endDate.getTime().equals(currenlyTime.getTime()))){
                    currentlyWeek = week.getWeekNumber();
                }
                weeks.add(week);
            }
            //为下次循环做准备，周数加一，开始时间与结束时间 +7
            weekNumber += 1;
            startDate.add(Calendar.DATE,7);
            endDate.add(Calendar.DATE,7);

        }
        map.put("weeks",weeks);
        map.put("currentlyWeek",currentlyWeek);
        return map;
    }

    //通过开始时间与计算时间计算周数与具体信息
    public static List<String> buildList(Date startDate1,Date endDate1){
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        List<String> list = new ArrayList<>();
        //转化起始时间
        Calendar startCalendar = Calendar.getInstance();
        startCalendar.setTime(startDate1);
        //转化结束时间
        Calendar endCalendar = Calendar.getInstance();
        endCalendar.setTime(endDate1);
        //遍历用时间
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(startDate1);
        int flag = 1;
        String s = "";
        while(!calendar.after(endCalendar)){
            int weekOfDay = calendar.get(Calendar.DAY_OF_WEEK);
            //第一周判断是否为完整的一周
            if(flag == 1 && calendar.get(Calendar.DAY_OF_WEEK) != 2){
                //如果不是时间往前推移，直到星期一，此间字符串添加','
                Calendar calendar2 = Calendar.getInstance();
                calendar2.setTime(startDate1);
                while(calendar2.get(Calendar.DAY_OF_WEEK) != 2){
                    s += "0,";
                    calendar2.add(Calendar.DATE,-1);
                }
                flag = 0;
                continue;
            }
            //平常周，判断是否为周日
            if(weekOfDay != 1){
                String formatTime = sdf.format(calendar.getTime());
                s += formatTime+",";
                calendar.add(Calendar.DATE,1);

            }else{
                String formatTime = sdf.format(calendar.getTime());
                s += formatTime+",";
                s = s.substring(0,s.length() - 1);
                //因为是周日，所以List添加一条数据，开始下一周的遍历
                list.add(s);
                s = "";
                calendar.add(Calendar.DATE,1);
            }
        }
        int flag2 = 0;
        //因为最后一周如果没有周日的话会跳出循环，字符串s依然有值，将最后的值插入List中
        while(calendar.get(Calendar.DAY_OF_WEEK)  != 1 || flag2 == 1){
            if(calendar.get(Calendar.DAY_OF_WEEK) == 1){
                s += "0,";
                s = s.substring(0,s.length() - 1);
                list.add(s);
                break;
            }else {
                s += "0,";
                calendar.add(Calendar.DATE,1);
                flag2 = 1;
            }
        }
        return list;
    }


}
