package org.rcisoft.business.texaminfo.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.texaminfo.entity.TExamDetail;
import org.rcisoft.core.base.BaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Repository
public interface TExamDetailRepository extends BaseMapper<TExamDetail> {

    /**
    * 分页查询 tExamDetail
    *
    */
    @Select("<script>select * from t_exam_detail where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if>' "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if>' "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TExamDetail> queryTExamDetails(TExamDetail tExamDetail);

    @Insert("<script>INSERT INTO t_exam_detail " +
            "(p_id,e_id,q_id,u_id,u_answer,qtype)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.pId},#{item.eId},#{item.qId},#{item.uId},#{item.uAnswer},#{item.qtype})" +
            "</foreach></script>")
    int insertList(List<TExamDetail> examDetails);

    @Select("select u_answer from t_exam_detail where e_id = #{eId} and q_id = #{qId} and u_id = #{userId}")
    String queryUAnswer(@Param("qId") String qId, @Param("userId") String userId, @Param("eId") String eId);
}

