package org.rcisoft.business.texaminfo.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.texaminfo.entity.TExamDetail;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.texaminfo.entity.TExamInfo;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Repository
public interface TExamInfoRepository extends BaseMapper<TExamInfo> {

    /**
    * 分页查询 tExamInfo
    *
    */
    @Select("<script>select * from t_exam_info where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TExamInfo> queryTExamInfos(TExamInfo tExamInfo);

    @Select("<script>select * from t_exam_info where p_id = #{paperId} and del_flag = 0 and flag = 1 limit 1</script>")
    @ResultMap(value = "BaseResultMap" )
    TExamInfo selectExamInfoByPid(String paperId);

    @Select("<script> select business_id from t_paper where chap_id = #{chapterId} order by status asc </script>")
    List<String> queryPidByChapterId( @Param("chapterId") String chapterId);

    @Update("<script> update t_paper set status = '1' where business_id = #{pId} </script>")
    void updateStatus( @Param("pId") String pId);

    @Select("<script>select ei.business_id,ei.p_id from t_exam_info ei \n" +
            "LEFT JOIN t_paper tp on tp.business_id = ei.p_id \n" +
            "where ei.u_id = #{userId} \n" +
            "and tp.chap_id = #{chapId}</script>")
    @ResultMap(value = "BaseResultMap" )
    TExamInfo queryIdByUserId(@Param("userId") String userId, @Param("chapId") String chapId);

    @Select("<script> select p_id from t_exam_info where business_id = #{examInfoId} </script>")
    String queryPaperIdById(String examInfoId);

}

