package org.rcisoft.business.tpaper.dao;

import org.apache.ibatis.annotations.Insert;
import org.rcisoft.business.tpaper.entity.TPaperSection;
import org.rcisoft.business.tpaperchapter.dto.SectionIdDto;
import org.rcisoft.core.base.BaseMapper;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Repository
public interface TPaperSectionRepository extends BaseMapper<TPaperSection> {

    /**
    * 分页查询 tPaperSection
    *
    */
    @Select("<script>select * from t_paper_section where 1=1 "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if>' "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if>' "
            + "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TPaperSection> queryTPaperSections(TPaperSection tPaperSection);

    @Insert("<script>INSERT INTO t_paper_section " +
            "(p_id,sdesc,sorder,q_type)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.pId},#{item.sdesc},#{item.sorder},#{item.qType})" +
            "</foreach></script>")
    int insertList(List<TPaperSection> tPaperSections);


    @Select("<script>SELECT \n" +
            "(SELECT business_id from t_paper_section where p_id = #{pid} AND q_type = '1')AS choiceId,\n" +
            "(SELECT business_id from t_paper_section where p_id = #{pid} AND q_type = '3')AS judgmentId,\n" +
            "(SELECT business_id from t_paper_section where p_id = #{pid} AND q_type = '2')AS multiSelectId\n" +
            " from t_paper_section </script>")
    List<SectionIdDto> querySectionIdByPid(String pid);

}

