package org.rcisoft.business.tpaper.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.AutoIncrementEntity;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_paper_section")
public class TPaperSection  extends AutoIncrementEntity<TPaperSection> {


     private static final long serialVersionUID = -2596263315203973219L;
    @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
    @NotBlank
     private String pId;
    @Length(min = 1,max = 200,message = "长度最小为1,最大为150")
    @NotBlank
     private String sdesc;

     private Integer sorder;

     private String qType;


    public TPaperSection(String pId) {
        this.pId = pId;
    }
}

