package org.rcisoft.business.tpaperchapter.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.tpaperchapter.entity.TPaperChapterSection;
import org.rcisoft.business.tquestion.entity.QuestionNumDto;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by yangzhaojun on 2018/1/26.
 */

@Repository
public interface TPaperChapterSectionRepository extends BaseMapper<TPaperChapterSection> {

    @Insert("<script>INSERT INTO t_paper_chapter_section " +
            "(pc_id,sdesc,q_num,q_type)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.pcId},#{item.sdesc},#{item.qNum},#{item.qType})" +
            "</foreach></script>")
    int insertList(List<TPaperChapterSection> tPaperChapterSections);

    @Select("SELECT DISTINCT(pc_id),\n" +
            "(SELECT q_num from t_paper_chapter_section where q_type = '1' and pc_id = #{pcId}) as NumOfChoice,\n" +
            "(SELECT q_num from t_paper_chapter_section where q_type = '2' and pc_id = #{pcId}) as NumOfMultiSelect,\n" +
            "(SELECT q_num from t_paper_chapter_section where q_type = '3' and pc_id = #{pcId}) as NumOfJudgment\n" +
            " from t_paper_chapter_section WHERE pc_id = #{pcId}")
    QuestionNumDto queryNumByPcId(String pcId);
}
