package org.rcisoft.business.tpaperchapter.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.business.tquestion.entity.QuestionNumDto;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_paper_chapter")
public class TPaperChapter  extends IdEntity<TPaperChapter> {

     private static final long serialVersionUID = 5201491638420229438L;

     private String pdesc;
     @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
     @NotBlank
     private String slId;
     @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
     @NotBlank
     private String chapId;

     private Float pScore;
     @Length(min = 1,max = 1,message = "长度最小为1,最大为1")
     @NotBlank
     private String poption;

     private String pscope;

     private String pcompose;

     @Transient
     private String choiceIds;

     @Transient
     private String judgmentIds;

     @Transient
     private String multiSelectIds;


     @Transient
     private QuestionNumDto questionNumDto;


}

