package org.rcisoft.business.tquestion.dao;

import org.apache.ibatis.annotations.*;
import org.rcisoft.business.tquestion.entity.QuestionNumDto;
import org.rcisoft.business.tquestion.entity.TQuestionOptions;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.tquestion.entity.TQuestion;
import org.rcisoft.core.model.PersistModel;
import org.springframework.stereotype.Repository;


import java.util.List;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Repository
public interface TQuestionRepository extends BaseMapper<TQuestion> {

    /**
    * 分页查询 tQuestion
    *
    */
    @Select("<script>select * from t_question where sl_id = #{slId} "
            + "<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            + "<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            + "<if test=\"qtype != null and qtype != '' \">and qtype = #{qtype} </if>"
            + "<if test=\"qtitle != null and qtitle != '' \">and qtitle LIKE CONCAT ('%',#{qtitle},'%')</if> "
            + "<if test=\"chapId !=null and chapId != '' \">and chap_id = #{chapId}</if> "
            + "order by update_date desc</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TQuestion> queryTQuestions(TQuestion tQuestion);


    /*@Select("<script>select * "
            +"from t_question tq"
            +"left join t_question_options tqo on tqo.qid = tq.business_id"
            +"where 1=1"
            +"<if test=\"delFlag !=null and delFlag != '' \">and del_flag = #{delFlag} </if> "
            +"<if test=\"flag !=null and flag != '' \">and flag = #{flag} </if> "
            +"<if test=\"business_id != null and business_id != ''\">and business_id = #{business_id}</if></script>")
    List<TQuestion> queryTQuestions(TQuestion tQuestion);*/

    @Update("<script> update t_question set del_flag = 1 , flag = 0 where FIND_IN_SET(business_id,#{idInfoList})</script>")
    int deleteByIds(String idInfoList);

    @Insert("<script>INSERT INTO t_question_options " +
            "(business_id,qid,represent,alias)VALUES " +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.businessId},#{item.qid},#{item.represent},#{item.alias})" +
            "</foreach></script>")
    int insertOptionsList(List<TQuestionOptions> optionList);

    @Select("<script>SELECT tq.qanswer,tq.qtype,tq.business_id,tq.qtitle,tq.qdesc FROM t_question tq\n" +
            "LEFT JOIN t_paper_detail tpd on tq.business_id = tpd.q_id\n" +
            "LEFT JOIN t_paper_section tps on tps.business_id = tpd.ps_id\n" +
            "LEFT JOIN t_paper tp on tp.business_id = tps.p_id\n" +
            "WHERE tp.business_id = #{pId}</script>"
    )
    @ResultMap(value = "BaseResultMap" )
    List<TQuestion> queryQuestionsByChap_IdAndQtype( @Param("pId") String pId);


    @Select("<script>select q_num from t_paper_chapter_section pcs " +
            "LEFT JOIN t_paper_chapter tpc ON tpc.business_id = pcs.pc_id " +
            "where q_type = #{qtype} and tpc.chap_id = #{chapId}</script>")
    List<String> queryNumByType(@Param("qtype") String qtype,@Param("chapId") String chapId);


    @Select("<script>SELECT tq.* from t_question tq \n" +
            "LEFT JOIN t_paper_detail pd ON tq.business_id = pd.q_id\n" +
            "LEFT JOIN t_paper tp ON pd.p_id = tp.business_id\n" +
            "where tp.chap_id = #{chapterId}</script>")
    @ResultMap(value = "BaseResultMap" )
    List<TQuestion> queryChapterQuestionsByChapterId(String chapterId);

    @Select("<script>SELECT DISTINCT(sl_id),\n" +
            "IFNULL((SELECT COUNT(*) from t_question where sl_id = #{slId}\n" +
            "   and chap_id = #{chapterId}\n" +
            "   and qtype = '1' and del_flag = '0'and flag = '1'),0) as chapChoiceNum,\n" +
            "IFNULL((SELECT COUNT(*) from t_question where sl_id = #{slId}\n" +
            "   and chap_id = #{chapterId}\n" +
            "   and qtype = '2' and del_flag = '0'and flag = '1'),0) as chapMultiSelectNum,\n" +
            "IFNULL((SELECT COUNT(*) from t_question where sl_id = #{slId}\n" +
            "   and chap_id = #{chapterId}\n" +
            "   and qtype = '3' and del_flag = '0'and flag = '1'),0) as chapJudgmentNum,\n" +
            "IFNULL((SELECT COUNT(*) from t_question where sl_id = #{slId}\n" +
            "   and qtype = '1' and del_flag = '0'and flag = '1'),0) as slChoiceNum,\n" +
            "IFNULL((SELECT COUNT(*) from t_question where sl_id = #{slId}\n" +
            "   and qtype = '2' and del_flag = '0'and flag = '1'),0) as slMultiSelectNum,\n" +
            "IFNULL((SELECT COUNT(*) from t_question where sl_id = #{slId}\n" +
            "   and qtype = '3' and del_flag = '0'and flag = '1'),0) as slJudgmentNum\n" +
            " from t_question WHERE sl_id = #{slId}</script>")
    QuestionNumDto queryQuestionNum(@Param("slId") String slId, @Param("chapterId") String chapterId);
}

