package org.rcisoft.business.tquestion.entity;

import lombok.*;

import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotBlank;
import org.rcisoft.core.entity.IdEntity;
import javax.persistence.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
* Created with yangzhaojun on 2018-1-15 19:49:07.
*/
@Entity
@Data
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "t_question")
public class TQuestion  extends IdEntity<TQuestion> {


     private static final long serialVersionUID = 4926963786636914161L;
     @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
     @NotBlank
     private String slId;
     @Length(min = 1,max = 64,message = "长度最小为1,最大为50")
     @NotBlank
     private String chapId;

     private String qtype;
     @Length(min = 1,max = 200,message = "长度最小为1,最大为180")
     @NotBlank
     private String qtitle;
     @Length(min = 1,max = 300,message = "长度最小为1,最大为180")
     @NotBlank
     private String qdesc;
     @Length(min = 1,max = 20,message = "长度最小为1,最大为15")
     @NotBlank
     private String qanswer;

     /*private String qid;

     private String alias;

     private String desc;*/

     /*1 随机 2 自主*/
     @Transient
     private String stateBeforeUpdate;

     /*1 全部 2 本节*/
     @Transient
     private String composeBeforeUpdate;

     @Transient
     private String pcompose;

     @Transient
     private String userId;

     @Transient
     List<TQuestionOptions> options;


     @Transient
     private String questionOptions;

     @Transient
     private String inUse;

     @Transient
     private String uanswer;

    public TQuestion(String businessId) {
         this.businessId = businessId;
    }
}

