package org.rcisoft.business.tquestion.service;

import org.rcisoft.business.tquestion.dto.QuestionListAndNumDto;
import org.rcisoft.business.tquestion.entity.TQuestion;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.aop.PageUtil;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by yangzhaojun on 2018-1-15 19:49:07.
 */
public interface TQuestionService {

    /**
    * 保存 
    * @param tQuestion
    * @return
    */
    PersistModel save(TQuestion tQuestion);

    /**
    * 逻辑删除 
    * @param id
    * @return
    */
     int remove(String id, String token);

    /**
    * 修改 
    * @param tQuestion
    * @return
    */
    PersistModel merge(TQuestion tQuestion);

    /**
    * 根据id查询 
    * @param id
    * @return
    */
    TQuestion findById(String id);

    /**
    * 分页查询 
    * @param tQuestion
    * @return
    */
    List<TQuestion> findAllByPagination(PageUtil<TQuestion> paginationUtility,TQuestion tQuestion);


    List<TQuestion> queryTQuestions(TQuestion tQuestion);

    int removeByIds(String idInfoList);

    TQuestion queryTQestionById(String businessId);

    /**
     * 根据章节ID和题目类型查询题目
     * @param chapterId
     * @return
     */
    QuestionListAndNumDto queryQuestionsByChap_IdAndQtype(String chapterId, String userId, HttpServletRequest request);

    List<TQuestion> queryTQuestionBySlId(TQuestion tQuestion);

}
