package org.rcisoft.common.component;

import com.google.common.collect.Maps;
import lombok.Data;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/2
 * Time: 下午3:50
 * description: global config
 */
@Component
@Data
public class Global {


    /**
     * 保存全局属性值
     */
    static Map<String, String> map = Maps.newHashMap();



    /*服务器地址*/
    @Value("${global.other.server_url}")
    private String SERVER_URL;

    /*服务器保存图片路径*/
    @Value("${global.path.base_upload_server_location}")
    private String BASE_UPLOAD_SERVER_LOCATION;



    /*容器外路径*/
    @Value("${global.path.physical_upload_server_location}")
    private String PHYSICAL_UPLOAD_SERVER_LOCATION;


    /*课程相关文件路径*/
    @Value("${global.path.course_location}")
    private String COURSE_LOCATION;

    /*lesson相关文件路径*/
    @Value("${global.path.lesson_location}")
    private String LESSON_LOCATION;

    /*sl相关文件路径*/
    @Value("${global.path.sl_location}")
    private String SL_LOCATION;

    /*服务器freemarker模板位置*/
    @Value("${global.path.freemarker_location}")
    private String FREEMARKER_LOCATION;

    /*服务器上传路径*/
    @Value("${global.path.image_location}")
    private String IMAGE_LOCATION;

    /*视频路径*/
    @Value("${global.path.video_location}")
    private String VIDEO_LOCATION;

    /*旧视频路径*/
    @Value("${global.path.temp_location}")
    private String TEMP_LOCATION;

    /*附件路径*/
    @Value("${global.path.file_location}")
    private String FILE_LOCATION;

    /*ppt路径*/
    @Value("${global.path.ppt_location}")
    private String PPT_LOCATION;

    /*pdf路径*/
    @Value("${global.path.pdf_location}")
    private String PDF_LOCATION;

    /*切割pdf路径*/
    @Value("${global.path.cut_pdf_location}")
    private String CUT_PDF_LOCATION;

    /*每次切割pdf的页数*/
    @Value("${global.other.cut_pdf_num}")
    private Integer CUT_PDF_NUM;

    /*excel模板位置*/
    @Value("${global.path.excel_template_location}")
    private String EXCEL_TEMPLATE_LOCATION;

    /*课程封面路径*/
    @Value("${global.path.cource_logo_location}")
    private String COURSE_LOGO_LOCATION;

    /*课程代码路径*/
    @Value("${global.path.cource_code_location}")
    private String COURSE_CODE_LOCATION;

    /*课程工程代码路径*/
    @Value("${global.path.cource_project_location}")
    private String COURSE_PROJECT_LOCATION;

    /*图片路径*/
    @Value("${global.path.images_location}")
    private String IMAGES_LOCATION;

    /*课程默认图片路径*/
    @Value("${global.default_location.course}")
    private String DEFAULT_COURSE_LOCATION;

    /*默认学生头像路径*/
    @Value("${global.default_location.student}")
    private String DEFAULT_STUDENT_LOCATION;

    /*默认教师头像路径*/
    @Value("${global.default_location.teacher}")
    private String DEFAULT_TEACHER_LOCATION;

    /*默认轮播图路径*/
    @Value("${global.default_location.carousel}")
    private String DEFAULT_CAROUSEL_LOCATION;

    /*开课封面路径*/
    @Value("${global.path.lanch_logo_location}")
    private String LANCH_LOGO_LOCATION;

    /*mdtup*/
    @Value("${global.path.md_file_location}")
    private String MD_FILE_LOCATION;

    /*登录验证秘钥*/
    @Value("${jwt.login_secert_key}")
    private String LOGIN_SECERT_KEY;
    
    @Value("${jwt.header}")
    private String JWT_HEADER;
    
    @Value("${jwt.tokenHead}")
    private String JWT_TOKEN_HEAD;

    /*是否是服务器（为1代表是服务器）*/
    @Value("${global.other.is_server_linux}")
    private String IS_SERVER_LINUX;

    /*code长度限制*/
    @Value("${global.other.max_code_length}")
    private String MAX_CODE_LENGTH;

    /*用户默认密码*/
    @Value("${global.password.default}")
    private String DEFAULT_PASSWORD;

    /*password最小长度*/
    @Value("${global.password.min_password}")
    private String PASSWORD_MIN_PASSWORD;

    /*password最大长度*/
    @Value("${global.password.max_password}")
    private String PASSWORD_MAX_PASSWORD;

    /*che的配置模板路径*/
    @Value("${global.path.che_def_template_location}")
    private String CHE_DEF_TEMPLATE_LOCATION;

    /*che初始化项目目录*/
    @Value("${global.path.che_project_init_location}")
    private String CHE_PROJECT_INIT_LOCATION;

    /*管理员Code*/
    @Value("${global.code.admin}")
    private String adminCode;

    /*教师Code*/
    @Value("${global.code.teacher}")
    private String teacherCode;

    /*学生Code*/
    @Value("${global.code.student}")
    private String studentCode;


    /*java 单文件*/
    @Value("${global.code.java_simple}")
    private String javaSimple;

    /*java 工程*/
    @Value("${global.code.java_project}")
    private String javaProject;

    /*html 单文件*/
    @Value("${global.code.html_simple}")
    private String htmlSimple;

    /*html 工程*/
    @Value("${global.code.html_project}")
    private String htmlProject;


    /**
     * 容器
     */
    @Value("${lxc.lxc_prefix}")
    private String lxcPrefix;

    @Value("${lxc.lxc_ports}")
    private String lxcPorts;

    @Value("${lxc.lxc_dockerfilePath}")
    private String lxcDockerfilePath;

    @Value("${lxc.lxc_initPort}")
    private Integer lxcInitPort;

    @Value("${lxc.lxc_maxPort}")
    private Integer lxcMaxPort;
    /**
     * 容器时间
     */
    @Value("${lxc.lxc_minu}")
    private Integer lxcMinu;
    /*延长界限*/
    @Value("${lxc.lxc_endlineTime}")
    private Integer lxcEndlineTime;

    /*延长时间*/
    @Value("${lxc.lxc_delayTime}")
    private Integer lxcDelayTime;

    @Value("${lxc.lxc_isRemote}")
    private String lxcIsRemote;


    /*libreoffice ip*/
    @Value("${libreoffice.ip}")
    private String libreofficeIp;

    /*libreoffice 端口*/
    @Value("${libreoffice.port}")
    private Integer libreofficePort;




    /*导出的学生作业暂存路径*/
    @Value("${global.path.student_code_location}")
    private String STUDENT_CODE_LOCATION;

    /*openOffice安装路径*/
    @Value("${global.other.open_office_home}")
    private String OPEN_OFFICE_HOME;

    /*redis缓存超时时间*/
    @Value("${spring.redis.timeout}")
    private Integer REDIS_TIMEOUT;

    @Value("${global.path.xml_location}")
    private String XML_LOCATION;
}
