package org.rcisoft.common.controller;

import org.rcisoft.core.result.ResponseMessage;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.validate.ValidatedResult;
import org.springframework.validation.BindingResult;

import java.util.Map;

/**
 * @descript validated controller
 * @author cy
 * Created by cy on 16/5/20.
 */

public class ValidatedController extends  HttpServletController {
    protected static final String VALIDMESSAGESKEY = "validerrors";

    private static String ERROR_PAGE = null;

    public String getErrorPage(){
        return null;
    }


    public ValidatedController() {
    }

    /**
     * 第一版  验证写在controller里的
     * @param br
     * @return
     */
    public boolean hasErrors(BindingResult br) {
        ValidatedResult vr = ValidatedResult.builder(br);
        this.request.setAttribute("validerrors", vr);
        return vr.hasErrors().booleanValue();
    }

    /**
     * 第二版写在  aop里的
     * @param br
     * @return
     */
    public static boolean hasErrorsByStatic(BindingResult br) {
        ValidatedResult vr = ValidatedResult.builder(br);
        return vr.hasErrors().booleanValue();
    }

    public Map<String, String[]> getErrorsMap() {
        ValidatedResult vr = (ValidatedResult)this.request.getAttribute("validerrors");
        return vr.getErrorsMap();
    }

    public ValidatedResult getValidatedResult() {
        ValidatedResult vr = (ValidatedResult)this.request.getAttribute("validerrors");
        return vr;
    }

    public ResponseMessage getValidatedMessage() {
        ValidatedResult vr = (ValidatedResult)this.request.getAttribute("validerrors");
        return vr.getValidatedMessage();
    }

    protected void setBindError(BindingResult br, Result result, String message){
        ValidatedResult vr = ValidatedResult.builder(br);
        result.setErrorMessage(message,vr);
    }
}
