package org.rcisoft.config;

import org.apache.poi.ss.formula.functions.T;
import org.rcisoft.core.aop.EntityParamAspect;
import org.rcisoft.core.aop.IdGenAspect;
import org.rcisoft.core.aop.PageUtil;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * Created by lcy on 18/1/21.
 */
@Configuration
public class AopConfig {


    /**
     * 分页 bean
     * @return
     */
    @Bean
    public PageUtil<T> pageUtil(){
        return new PageUtil<T>();
    }

    /**
     * id bean
     * @return
     */
    @Bean
    public IdGenAspect idGenAspect(){
        return new IdGenAspect();
    }

    /**
     *  web param validation
     * @return
     */
    @Bean
    public EntityParamAspect entityParamAspect(){
        return new EntityParamAspect();
    }
}
