package org.rcisoft.config;

import org.rcisoft.core.component.RcJobFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.quartz.SchedulerFactoryBean;

/**
 * Created by lcy on 18/1/10.
 */
@Configuration
public class QuartzConfig {



    @Autowired
    private RcJobFactory rcJobFactory;

    /**
     * attention:
     * Details：定义quartz调度工厂
     */
    @Bean(name = "scheduler")
    public SchedulerFactoryBean schedulerFactory() {
        SchedulerFactoryBean bean = new SchedulerFactoryBean();
        /*可以注入bean*/
        bean.setJobFactory(rcJobFactory);
        // 用于quartz集群,QuartzScheduler 启动时更新己存在的Job
        bean.setOverwriteExistingJobs(true);
        // 延时启动，应用启动1秒后
        bean.setStartupDelay(1);
        // 注册触发器
        //bean.setTriggers(cronJobTrigger);
        return bean;
    }
}
