package org.rcisoft.core.handler;

import com.alibaba.fastjson.JSON;
import lombok.extern.slf4j.Slf4j;
import org.springframework.aop.interceptor.AsyncUncaughtExceptionHandler;

import java.lang.reflect.Method;

/**
 * Created by lcy on 18/1/25.
 */
@Slf4j
public class RcAsyncExceptionHandler implements AsyncUncaughtExceptionHandler {

    @Override
    public void handleUncaughtException(Throwable ex, Method method, Object... params) {
        log.info("Async method: {} has caught exception,params:{}", method.getName(), JSON.toJSONString(params));
        log.error("executor exception --> " + ex.getMessage());

    }
}
