package org.rcisoft.core.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializerProvider;

import java.io.IOException;


/**
 * Created by YangZhaojun on 2018/1/3.
 * 自定义ObjectMapper
 * springBoot返回json数据时会将数据库为null的字段过滤，前台看不见返回值，这个类是null值转化为空字符串操作，便于前台判断
 */

public class NullSerializer extends ObjectMapper {

    private static final long serialVersionUID = -2785650514571869859L;

    public NullSerializer(){
        super();
        // null值处理为空字符串
        this.getSerializerProvider().setNullValueSerializer(new JsonSerializer<Object>() {
            @Override
            public void serialize(Object value, JsonGenerator jg, SerializerProvider sp)
                    throws IOException, JsonProcessingException {
                jg.writeString("");
            }
        });
    }
}
