package org.rcisoft.core.service;

import redis.clients.jedis.Jedis;

import java.util.List;

/**
 * Created by lcy on 18/1/8.
 */
public interface RcRedisService {

    /**
     * 获取jedis
     * @return
     */
    public Jedis getResource();

    /**
     * 归还jedis
     * @param jedis
     */
    public void returnResource(Jedis jedis);

    /**
     * 赋值
     * @param key
     * @param value
     */
    public void set(String key, String value);
    /**
     * 赋值字节数组 设置过期
     * @param key
     * @param value
     */
    public void set(String key, String value,int expire);

    /**
     * 赋值字节数组
     * @param key
     * @param value
     */
    public void setBytes(String key, byte[] value);
    /**
     * 赋值字节数组 设置过期
     * @param key
     * @param value
     */
    public void setBytes(String key, byte[] value,int expire);

    /**
     * 取值
     * @param key
     * @return
     */
    public String get(String key);

    /**
     * 取值数组
     * @param key
     * @return
     */
    public byte[] getBytes(String key);

    /**
     * 清除
     * @param key
     */
    public void remove(String key);

    /**
     * 获取list
     * @param key
     */
    public List getList(String key);

    /**
     * set list
     * @param key
     * @param value
     */
    public void setList(String key,String value);

    /**
     * 从 list 中 删除
     * @param key
     */
    public void removeList(String key,String value);
}
