package org.rcisoft.core.util;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.pdf.PdfCopy;
import com.itextpdf.text.pdf.PdfImportedPage;
import com.itextpdf.text.pdf.PdfReader;
import org.springframework.stereotype.Component;

import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;

/**
 * Created by yangzhaojun on 2018/2/6.
 */
@Component
public class CutPdfUtil {
    public static void main(String[] args) throws Exception{
        Date dd = new Date();
        long l1 = dd.getTime();

        int i = 0;
        int j = 1;
        boolean finish = false;
        String filePath = "E:\\pdfTest\\a9c9c7916e424c3aa44255564c31bbe9.pdf";
        PdfReader reader = new PdfReader(filePath);
        int pageNum = reader.getNumberOfPages();
        do{
            String newFile = "E:\\pdfTest\\cutPdf\\a9c9c7916e424c3aa44255564c31bbe9"+j+".pdf";
            int end = i+30;
            if(end>=pageNum){
                end = pageNum;
                finish = true;
            }
            partitionPdfFile(reader, newFile, i+1,end);
            System.out.println("第"+j+"个pdf转换完成");
            i+=30;
            j++;
        }while (!finish);
        Date dd2 = new Date();
        long l2 = dd2.getTime();
        System.out.println("耗时："+(l2 - l1));
    }

    /**
     * 截取pdfFile的第from页至第end页，组成一个新的文件名
     * @param reader
     * @param newFile
     * @param from
     * @param end
     */
    public static void partitionPdfFile(PdfReader reader,
                                        String newFile, int from, int end) {
        Document document = null;
        PdfCopy copy = null;
        try {
            document = new Document(reader.getPageSize(1));
            copy = new PdfCopy(document, new FileOutputStream(newFile));
            document.open();
            for(int j=from; j<=end; j++) {
                document.newPage();
                PdfImportedPage page = copy.getImportedPage(reader, j);
                copy.addPage(page);
            }
            document.close();

        } catch (IOException e) {
            e.printStackTrace();
        } catch(DocumentException e) {
            e.printStackTrace();
        }
    }
}
