package org.rcisoft.core.util;

import com.artofsolving.jodconverter.BasicDocumentFormatRegistry;
import com.artofsolving.jodconverter.DocumentConverter;
import com.artofsolving.jodconverter.DocumentFormat;
import com.artofsolving.jodconverter.DocumentFormatRegistry;
import com.artofsolving.jodconverter.openoffice.connection.OpenOfficeConnection;
import com.artofsolving.jodconverter.openoffice.connection.SocketOpenOfficeConnection;
import com.artofsolving.jodconverter.openoffice.converter.OpenOfficeDocumentConverter;
import lombok.extern.slf4j.Slf4j;
import org.rcisoft.common.component.Global;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.result.ResultServiceEnums;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.io.File;
import java.io.IOException;
import java.net.ConnectException;

/**
 * Created by Administrator on 2018/1/19.
 */
@Component
@Slf4j
public class OfficeToPdf {

    @Autowired
    private Global global;

    /*
    private static OfficeManager officeManager;
    private static int port[] = { 8100 };

    public void pptToPdf(String inputFile, String outputFile) throws FileNotFoundException {

        startService();
        System.out.println("进行文档转换转换:" + inputFile + " --> " + outputFile);

        OfficeDocumentConverter converter = new OfficeDocumentConverter(officeManager);
        converter.convert(new File(inputFile), new File(outputFile));

        stopService();

    }

    // 打开服务器
    public void startService() {
        DefaultOfficeManagerConfiguration configuration = new DefaultOfficeManagerConfiguration();
        try {
            System.out.println("准备启动服务....");
            configuration.setOfficeHome(global.getOPEN_OFFICE_HOME());// 设置OpenOffice.org安装目录
            configuration.setPortNumbers(port); // 设置转换端口，默认为8100
            configuration.setTaskExecutionTimeout(1000 * 60 * 5L);// 设置任务执行超时为5分钟
            configuration.setTaskQueueTimeout(1000 * 60 * 60 * 24L);// 设置任务队列超时为24小时

            officeManager = configuration.buildOfficeManager();
            officeManager.start(); // 启动服务
            System.out.println("office转换服务启动成功!");
        } catch (Exception ce) {
            System.out.println("office转换服务启动失败!详细信息:" + ce);
        }
    }

    // 关闭服务器
    public static void stopService() {
        System.out.println("关闭office转换服务....");
        if (officeManager != null) {
            officeManager.stop();
        }
        System.out.println("关闭office转换成功!");
    }*/

    public static void main(String[] args) throws Exception {
        String path = "C:/Users/Administrator/Desktop/";
        OfficeToPdf opc = new OfficeToPdf();
        opc.transformToPdf(path+"abc.pptx", path+"1.pdf");
    }

    /**
     * 转换pdf
     * @param sourceFile
     * @param destFile
     * @return  1 成功  0 失败  -1 错误
     */
    public synchronized  int transformToPdf(String sourceFile, String destFile){
        OpenOfficeConnection connection = null;
        try {
            File inputFile = new File(sourceFile);
            if (!inputFile.exists()) {
                return -1;// 找不到源文件, 则返回-1
            }
            // 如果目标路径不存在, 则新建该路径
            File outputFile = new File(destFile);
            if (!outputFile.getParentFile().exists()) {
                outputFile.getParentFile().mkdirs();
            }
            // connect to an OpenOffice.org instance running on port 8100
            connection = new SocketOpenOfficeConnection(
                    global.getLibreofficeIp(), global.getLibreofficePort());
            connection.connect();
            // convert
            DocumentConverter converter = new OpenOfficeDocumentConverter(
                    connection);
            DocumentFormatRegistry factory = new BasicDocumentFormatRegistry();
            DocumentFormat inputDocumentFormat = factory
                    .getFormatByFileExtension(FileUtil.getFilePostfix(sourceFile));
            DocumentFormat outputDocumentFormat = factory
                    .getFormatByFileExtension(FileUtil.getFilePostfix(destFile));
            log.info("开始转换--> "+ sourceFile);
            converter.convert(inputFile,inputDocumentFormat,outputFile,outputDocumentFormat);
            log.info("转换完毕--> "+ destFile);
            // close the connection
        } catch (ConnectException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
            return 0;
        }finally {
            if(connection!=null) {
                connection.disconnect();
            }else{
                throw new ServiceException(ResultServiceEnums.UPLOAD_ERROR);
            }
        }
        return 1;
    }


}
