package org.rcisoft.core.util;

import lombok.extern.slf4j.Slf4j;
import org.quartz.JobDetail;
import org.quartz.Scheduler;
import org.quartz.Trigger;

import java.io.Serializable;

/**
 * Created by lcy on 18/1/20.
 */
@Slf4j
public class TaskUtil implements Serializable{


    private static final long serialVersionUID = -4513365435486468892L;

    /**
     * 开启  schedule
     * @param sched
     * @param trigger
     * @param job
     * @return
     */
    public static boolean startSchedule(Scheduler sched,Trigger trigger,JobDetail job){
        try {
            sched.scheduleJob(job, trigger);
            // 启动
            if (!sched.isShutdown()) {
                sched.start();
            }
        }catch (Exception e){
            log.error(e.getMessage());
            return false;
        }
        return true;
    }
}
