package org.rcisoft.core.util;

import org.rcisoft.common.component.Global;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;


/**
 * Created by asus on 2017/7/24.
 */
public class UploadUtil {
    public static final String URL = "url";
    public static final String IS_SUCCESSS = "isSuccess";



    /**
     * @param basePath 基础路径（服务器上下午路径）
     * @param uploadPath   具体路径
     * @param multipartFile   上传的文件
     * @return
     */
    public static Map<String,Object> picImport(String basePath, String uploadPath, MultipartFile multipartFile, boolean type) {
        Map<String, Object> map = new HashMap<String, Object>();
        try {
            UUID uuid = UUID.randomUUID();
            Calendar calendar = Calendar.getInstance();
            String userPath = uploadPath +
                    File.separator+calendar.get(Calendar.YEAR)+
                    File.separator+calendar.get(Calendar.MONTH)+
                    File.separator+calendar.get(Calendar.DATE)+
                    File.separator;
            String realPath = basePath + File.separator+ userPath;
            //创建File对象，参数为String类型，表示目录名
            File dir = new File(realPath);
            //判断文件是否存在 dir.exists()
            if (!dir.exists()) {
                //如果你想根据File里的路径名建立文件夹（当你不知道此文件夹是否存在，也不知道父文件夹存在），
                // 就可用此方法，它建立文件夹的原则是：如果父文件夹不存在并且最后一级子文件夹不存在，
                // 它就自动新建所有路经里写的文件夹；如果父文件夹存在，它就直接在已经存在的父文件夹下新建子文件夹
                dir.mkdirs();
            }
            //split  函数是用于按指定字符（串）或正则去分割某个字符串，结果以字符串数组形式返回；
            String fileName = multipartFile.getOriginalFilename();
            String suffix =  fileName.substring(fileName.lastIndexOf("."),
                                                fileName.length()) ;
            String filename = uuid.toString() +  suffix;
            String fileurl = realPath + filename;
            multipartFile.transferTo(new File(fileurl));//上传到服务器，在服务器上新建一个文件夹，放图片，
            // 图片是multipartFile中包含的，也就是说，实际上传给我的参数中，multipartFile就是图片的代表。
            if(type) {
                Runtime.getRuntime().exec("chmod -R 755 " + basePath);
            }
            map.put(IS_SUCCESSS, true);
            map.put(URL, userPath.substring(0, userPath.length()) + filename);//url中是图片的路径，应该是服务器上图片
            //的路径，我在controller中调用这个方法时间，直接看返回值，如果isSuccess是true，则取出url,然后将其存入数据库，如果
            // 取出的isSuccess的值是false，就直接报错，跳到exception。
            return map;
        } catch (IOException e) {
            e.printStackTrace();
            map.put(IS_SUCCESSS, false);
            map.put(URL, "");
        } finally {
            return map;
        }
    }
}
