package org.rcisoft.core.util;

import io.jsonwebtoken.Claims;
import org.apache.commons.lang3.StringUtils;
import org.rcisoft.core.entity.IdEntity;
import org.rcisoft.core.model.JwtUser;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

import java.util.Date;

/**
 * Created by lcy on 17/11/28.
 */
public class UserUtil {

    /**
     * 用户id
     */
    public static final String USER_ID = "businessId";
    /**
     * 用户 username
     */
    public static final String USER_USERNAME = "username";

    /**
     * 获取用户信息
     * @param token
     * @param prop
     * @return
     */
    public static String getUserInfoProp(String token,String prop){
        if(StringUtils.isEmpty(token))
            return null;
        Claims claims = JwtUtil.getUserClaimsFromToken(token);
        return claims.get(prop).toString();
    }

    /**
     * 获取登录人 business_id
     * @return
     */
    public static String getAuthenBusinessId(){
        Authentication authen = SecurityContextHolder.getContext().getAuthentication();
        Object principal = authen.getPrincipal();

        if(null != principal && principal instanceof JwtUser)
            return  ((JwtUser) principal).getBusinessId();
        return null;
    }


    /**
     * 增加实体
     * @param entity
     */
    public static void setCurrentPersistOperation(IdEntity entity) {
        entity.setCreateBy(UserUtil.getAuthenBusinessId());
        entity.setCreateDate(new Date());
        entity.setUpdateBy(UserUtil.getAuthenBusinessId());
        entity.setUpdateDate(new Date());
        entity.setCommonBusinessId();
        entity.setNotDeleted();
        entity.setStart();
    }

    /**
     * 修改实体
     * @param entity
     */
    public static void setCurrentMergeOperation(IdEntity entity) {
        entity.setUpdateBy(UserUtil.getAuthenBusinessId());
        entity.setUpdateDate(new Date());
    }
}
