package org.rcisoft.sys.menu.service;



import org.rcisoft.common.model.CommonMenuModel;
import org.rcisoft.common.model.TreeViewModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.menu.entity.SysMenu;

import java.util.List;

/**
 * Created by lcy on 16/7/30.
 */
public interface SysMenuService {
    /**
     * 查询 Menu 根据树
     * @return
     */
    public List<TreeViewModel> queryMenuTree();

    /**
     * 保存部门
     * @param Menu
     * @return
     */
    PersistModel persistMenu(SysMenu Menu, String token);

    /**
     * 修改部门
     * @param Menu
     * @return
     */
    PersistModel mergeMenu(SysMenu Menu, String token);

    /**
     * 删除部门
     * @param id
     * @return
     */
    PersistModel removeMenu(String id, String token);

    /**
     * 根据id 查询 menu
     * @param id
     * @return
     */
    SysMenu queryMenuById(String id);

    /**
     * 获取全部菜单(角色已拥有的进行选中)
     * @param id    role id
     * @return
     */
    List<TreeViewModel> queryMenuTreeForSelectedByRP(String id);

    /**
     * 查询登录用户 菜单
     * @return
     */
    List<SysMenu> queryMenus();
}
