package org.rcisoft.sys.role.service;



import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.sys.dept.entity.DeptRole;
import org.rcisoft.sys.role.entity.SysRole;

import java.util.List;

/**
 * Created by lcy on 16/7/30.
 */
public interface SysRoleService {

    /**
     * 保存
     * @param sysRole
     * @return
     */
    int persistRole(SysRole sysRole, String token);


    /**
     * 删除
     * @param id
     * @return
     */
    int removeRole(String id, String token);
    
    /**
     * getByid
     */
    SysRole queryRoleById(String id);
    /**
     * 分页查询角色
     * @param pageUtil
     * @param sysRole
     * @return
     */
    public List<SysRole> queryRolesByPagination(PageUtil pageUtil, SysRole sysRole);

    //select 
    List<SysRole> queryRolesSelect(SysRole sysRole);

    /**
     * 授权(赋予角色 权限)
     * @param roleId
     * @param role_menus
     * @return
     */
    PersistModel doAuthorization(String roleId, String role_menus, String token);
    
    PersistModel doAuthorizationDept(String roleId, String role_menus, String token);
    /**
     * 分页查询角色   根据 userId   进行checked
     * @param paginationUtility
     * @param userId
     * @param sysRole
     * @return
     */
    public List<DeptRole> queryUserRolesByPagination(PageUtil<SysRole> paginationUtility, String userId, SysRole sysRole);

    /**
     *
     * @param paginationUtility
     * @param DeptId
     * @param sysRole
     * @return
     */
    public List<SysRole> queryDeptRolesByPagination(PageUtil<SysRole> paginationUtility, String DeptId, SysRole sysRole);
}
